VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHttpReqHeadCol"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IHttpRequestHeaderCollection As String = "{af40329b-b544-469b-86b9-ac3d466fea36}"

' * Class implements the following interfaces:
' *    Windows.Web.Http.Headers.IHttpRequestHeaderCollection ** Default Interface **
' *    Windows.Foundation.Collections.IMap`2<String, String>
' *    Windows.Foundation.Collections.IIterable`1<Windows.Foundation.Collections.IKeyValuePair`2<String, String>>
' *    Windows.Foundation.IStringable

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IHttpRequestHeaderCollection
'    IHttpRequestHeaderCollection_GetAccept = 6
'    IHttpRequestHeaderCollection_GetAcceptEncoding = 7
'    IHttpRequestHeaderCollection_GetAcceptLanguage = 8
'    IHttpRequestHeaderCollection_GetAuthorization = 9
'    IHttpRequestHeaderCollection_PutAuthorization = 10
'    IHttpRequestHeaderCollection_GetCacheControl = 11
'    IHttpRequestHeaderCollection_GetConnection = 12
'    IHttpRequestHeaderCollection_GetCookie = 13
'    IHttpRequestHeaderCollection_GetDate = 14
'    IHttpRequestHeaderCollection_PutDate = 15
'    IHttpRequestHeaderCollection_GetExpect = 16
'    IHttpRequestHeaderCollection_GetFrom = 17
'    IHttpRequestHeaderCollection_PutFrom = 18
'    IHttpRequestHeaderCollection_GetHost = 19
'    IHttpRequestHeaderCollection_PutHost = 20
'    IHttpRequestHeaderCollection_GetIfModifiedSince = 21
'    IHttpRequestHeaderCollection_PutIfModifiedSince = 22
'    IHttpRequestHeaderCollection_GetIfUnmodifiedSince = 23
'    IHttpRequestHeaderCollection_PutIfUnmodifiedSince = 24
'    IHttpRequestHeaderCollection_GetMaxForwards = 25
'    IHttpRequestHeaderCollection_PutMaxForwards = 26
'    IHttpRequestHeaderCollection_GetProxyAuthorization = 27
'    IHttpRequestHeaderCollection_PutProxyAuthorization = 28
'    IHttpRequestHeaderCollection_GetReferer = 29
'    IHttpRequestHeaderCollection_PutReferer = 30
'    IHttpRequestHeaderCollection_GetTransferEncoding = 31
'    IHttpRequestHeaderCollection_GetUserAgent = 32
'    IHttpRequestHeaderCollection_Append = 33
'    IHttpRequestHeaderCollection_TryAppendWithoutValidation = 34
                            
    ' IStringable
    IStringable_ToString = 6
    
End Enum

' ----==== Variablen ====----
Private m_pIStringable As Long
Private m_pIHttpRequestHeaderCollection As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIStringable)
    Call ReleaseIfc(m_pIHttpRequestHeaderCollection)
End Sub

' ----==== Properties ====----
Public Property Get IHttpRequestHeaderCollection() As Long
    IHttpRequestHeaderCollection = m_pIHttpRequestHeaderCollection
End Property

Public Property Let IHttpRequestHeaderCollection(ByVal pIHttpRequestHeaderCollection As Long)
    Call ReleaseIfc(m_pIStringable)
    Call ReleaseIfc(m_pIHttpRequestHeaderCollection)
    m_pIHttpRequestHeaderCollection = IHttpRequestHeaderCollection
    If m_pIHttpRequestHeaderCollection <> 0& Then
        Call QueryIfc(m_pIHttpRequestHeaderCollection, IID_IStringable, m_pIStringable)
    End If
End Property

' IHttpRequestHeaderCollection
'    IHttpRequestHeaderCollection_GetAccept = 6
'    IHttpRequestHeaderCollection_GetAcceptEncoding = 7
'    IHttpRequestHeaderCollection_GetAcceptLanguage = 8
'    IHttpRequestHeaderCollection_GetAuthorization = 9
'    IHttpRequestHeaderCollection_PutAuthorization = 10
'    IHttpRequestHeaderCollection_GetCacheControl = 11
'    IHttpRequestHeaderCollection_GetConnection = 12
'    IHttpRequestHeaderCollection_GetCookie = 13
'    IHttpRequestHeaderCollection_GetDate = 14
'    IHttpRequestHeaderCollection_PutDate = 15
'    IHttpRequestHeaderCollection_GetExpect = 16
'    IHttpRequestHeaderCollection_GetFrom = 17
'    IHttpRequestHeaderCollection_PutFrom = 18
'    IHttpRequestHeaderCollection_GetHost = 19
'    IHttpRequestHeaderCollection_PutHost = 20
'    IHttpRequestHeaderCollection_GetIfModifiedSince = 21
'    IHttpRequestHeaderCollection_PutIfModifiedSince = 22
'    IHttpRequestHeaderCollection_GetIfUnmodifiedSince = 23
'    IHttpRequestHeaderCollection_PutIfUnmodifiedSince = 24
'    IHttpRequestHeaderCollection_GetMaxForwards = 25
'    IHttpRequestHeaderCollection_PutMaxForwards = 26
'    IHttpRequestHeaderCollection_GetProxyAuthorization = 27
'    IHttpRequestHeaderCollection_PutProxyAuthorization = 28
'    IHttpRequestHeaderCollection_GetReferer = 29
'    IHttpRequestHeaderCollection_PutReferer = 30
'    IHttpRequestHeaderCollection_GetTransferEncoding = 31
'    IHttpRequestHeaderCollection_GetUserAgent = 32

' ----==== Functions ====----
' IHttpRequestHeaderCollection
'    IHttpRequestHeaderCollection_Append = 33
'    IHttpRequestHeaderCollection_TryAppendWithoutValidation = 34

' IStringable
Public Function ToString() As String
    Dim Ret As String
    If m_pIStringable <> 0 Then
        Dim hString As Long
        If Invoke(m_pIStringable, _
                  IStringable_ToString, _
                  VarPtr(hString)) = S_OK Then
            Ret = GetWindowsString(hString)
        End If
    End If
    ToString = Ret
End Function

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


