VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHttpResMsg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const WebHttpHttpResponseMessage As String = "Web.Http.HttpResponseMessage"
Private Const IID_IHttpResponseMessage As String = "{fee200fb-8664-44e0-95d9-42696199bffc}"
Private Const IID_IHttpResponseMessageFactory As String = "{52a8af99-f095-43da-b60f-7cfc2bc7ea2f}"

' * Class implements the interface:
' *    Windows.Foundation.IClosable
 
' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IHttpResponseMessageFactory
'    IHttpResponseMessageFactory_Create = 6
    
    ' IHttpResponseMessage
'                    virtual HRESULT STDMETHODCALLTYPE get_Content(
'                    virtual HRESULT STDMETHODCALLTYPE put_Content(
'                    virtual HRESULT STDMETHODCALLTYPE get_Headers(
'                    virtual HRESULT STDMETHODCALLTYPE get_IsSuccessStatusCode(
'                    virtual HRESULT STDMETHODCALLTYPE get_ReasonPhrase(
'                    virtual HRESULT STDMETHODCALLTYPE put_ReasonPhrase(
'                    virtual HRESULT STDMETHODCALLTYPE get_RequestMessage(
'                    virtual HRESULT STDMETHODCALLTYPE put_RequestMessage(
'                    virtual HRESULT STDMETHODCALLTYPE get_Source(
'                    virtual HRESULT STDMETHODCALLTYPE put_Source(
'                    virtual HRESULT STDMETHODCALLTYPE get_StatusCode(
'                    virtual HRESULT STDMETHODCALLTYPE put_StatusCode(
'                    virtual HRESULT STDMETHODCALLTYPE get_Version(
'                    virtual HRESULT STDMETHODCALLTYPE put_Version(
'                    virtual HRESULT STDMETHODCALLTYPE EnsureSuccessStatusCode(

    ' IStringable
    IStringable_ToString = 6
    
End Enum

' ----==== Variablen ====----
Private m_pIStringable As Long
Private m_pIHttpResponseMessage As Long
Private m_pIHttpResponseMessageFactory As Long

' ----==== Events ====----

' ----==== Class ====----
Private Sub Class_Initialize()
    If GetActivationFactory(WebHttpHttpResponseMessage, _
                            IID_IHttpResponseMessageFactory, _
                            m_pIHttpResponseMessageFactory) Then
    End If
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIStringable)
    Call Dispose(m_pIHttpResponseMessage) '<-IClosable
    Call Dispose(m_pIHttpResponseMessageFactory) '<-IClosable
End Sub

' ----==== Invoke Events ====----

' ----==== Properties ====----
Public Property Get IHttpResponseMessage() As Long
    IHttpResponseMessage = m_pIHttpResponseMessage
End Property

Public Property Let IHttpResponseMessage(ByVal pIHttpResponseMessage As Long)
    Call ReleaseIfc(m_pIStringable)
    Call Dispose(m_pIHttpResponseMessage) '<-IClosable
    m_pIHttpResponseMessage = pIHttpResponseMessage
    If m_pIHttpResponseMessage <> 0& Then
        Call QueryIfc(m_pIHttpResponseMessage, IID_IStringable, m_pIStringable)
    End If
End Property


' ----==== Functions ====----
    ' IHttpResponseMessageFactory
'    IHttpResponseMessageFactory_Create = 6
    
    ' IHttpResponseMessage



' IStringable
Public Function ToString() As String
    Dim Ret As String
    If m_pIStringable <> 0 Then
        Dim hString As Long
        If Invoke(m_pIStringable, _
                  IStringable_ToString, _
                  VarPtr(hString)) = S_OK Then
            Ret = GetWindowsString(hString)
        End If
    End If
    ToString = Ret
End Function

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


