VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHttpTransInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const WebHttpHttpResponseMessage As String = "Web.Http.HttpResponseMessage"
Private Const IID_IHttpTransportInformation As String = "{70127198-c6a7-4ed0-833a-83fd8b8f178d}"

' ----==== Enums ====----
Private Enum vtb_Interfaces

    ' IHttpTransportInformation
'    IHttpTransportInformation_GetServerCertificate=6
'    IHttpTransportInformation_GetServerCertificateErrorSeverity=7
'    IHttpTransportInformation_GetServerCertificateErrors=8
'    IHttpTransportInformation_GetServerIntermediateCertificates=9
    
    ' IStringable
    IStringable_ToString = 6
    
End Enum

' ----==== Variablen ====----
Private m_pIStringable As Long
Private m_pIHttpTransportInformation As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIStringable)
    Call ReleaseIfc(m_pIHttpTransportInformation)
End Sub

' ----==== Properties ====----
Public Property Get IHttpTransportInformation() As Long
    IHttpTransportInformation = m_pIHttpTransportInformation
End Property

Public Property Let IHttpTransportInformation(ByVal pIHttpTransportInformation As Long)
    Call ReleaseIfc(m_pIStringable)
    Call ReleaseIfc(m_pIHttpTransportInformation)
    m_pIHttpTransportInformation = pIHttpTransportInformation
    If m_pIHttpTransportInformation <> 0& Then
        Call QueryIfc(m_pIHttpTransportInformation, IID_IStringable, m_pIStringable)
    End If
End Property

' IHttpTransportInformation
'    IHttpTransportInformation_GetServerCertificate=6
'    IHttpTransportInformation_GetServerCertificateErrorSeverity=7
'    IHttpTransportInformation_GetServerCertificateErrors=8
'    IHttpTransportInformation_GetServerIntermediateCertificates=9

' ----==== Functions ====----
' IStringable
Public Function ToString() As String
    Dim Ret As String
    If m_pIStringable <> 0 Then
        Dim hString As Long
        If Invoke(m_pIStringable, _
                  IStringable_ToString, _
                  VarPtr(hString)) = S_OK Then
            Ret = GetWindowsString(hString)
        End If
    End If
    ToString = Ret
End Function

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


