VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControl As String = "{3f921316-bc70-4bda-9136-c94370899fab}"
Private Const IID_IWebViewControl2 As String = "{4d3c06f9-c8df-41cc-8bd5-2a947b204503}"
Private Const IID_IWebViewControlSite As String = "{133f47c6-12dc-4898-bd47-04967de648ba}"
Private Const IID_IWebViewControlSite2 As String = "{d13b2e3f-48ee-4730-8243-d2ed0c05606a}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControl
    IWebViewControl_GetSource = 6
    IWebViewControl_PutSource = 7
    IWebViewControl_GetDocumentTitle = 8
    IWebViewControl_GetCanGoBack = 9
    IWebViewControl_GetCanGoForward = 10
    IWebViewControl_PutDefaultBackgroundColor = 11
    IWebViewControl_GetDefaultBackgroundColor = 12
    IWebViewControl_GetContainsFullScreenElement = 13
    IWebViewControl_GetSettings = 14
    IWebViewControl_GetDeferredPermissionRequests = 15
    IWebViewControl_GoForward = 16
    IWebViewControl_GoBack = 17
    IWebViewControl_Refresh = 18
    IWebViewControl_Stop = 19
    IWebViewControl_Navigate = 20
    IWebViewControl_NavigateToString = 21
'    IWebViewControl_NavigateToLocalStreamUri = 22
'    IWebViewControl_NavigateWithHttpRequestMessage = 23
    IWebViewControl_InvokeScriptAsync = 24
'    IWebViewControl_CapturePreviewToStreamAsync = 25
'    IWebViewControl_CaptureSelectedContentToDataPackageAsync = 26
'    IWebViewControl_BuildLocalStreamUri = 27
    IWebViewControl_GetDeferredPermissionRequestById = 28
    IWebViewControl_AddNavigationStarting = 29
    IWebViewControl_RemoveNavigationStarting = 30
    IWebViewControl_AddContentLoading = 31
    IWebViewControl_RemoveContentLoading = 32
    IWebViewControl_AddDOMContentLoaded = 33
    IWebViewControl_RemoveDOMContentLoaded = 34
    IWebViewControl_AddNavigationCompleted = 35
    IWebViewControl_RemoveNavigationCompleted = 36
    IWebViewControl_AddFrameNavigationStarting = 37
    IWebViewControl_RemoveFrameNavigationStarting = 38
    IWebViewControl_AddFrameContentLoading = 39
    IWebViewControl_RemoveFrameContentLoading = 40
    IWebViewControl_AddFrameDOMContentLoaded = 41
    IWebViewControl_RemoveFrameDOMContentLoaded = 42
    IWebViewControl_AddFrameNavigationCompleted = 43
    IWebViewControl_RemoveFrameNavigationCompleted = 44
    IWebViewControl_AddScriptNotify = 45
    IWebViewControl_RemoveScriptNotify = 46
    IWebViewControl_AddLongRunningScriptDetected = 47
    IWebViewControl_RemoveLongRunningScriptDetected = 48
    IWebViewControl_AddUnsafeContentWarningDisplaying = 49
    IWebViewControl_RemoveUnsafeContentWarningDisplaying = 50
    IWebViewControl_AddUnviewableContentIdentified = 51
    IWebViewControl_RemoveUnviewableContentIdentified = 52
    IWebViewControl_AddPermissionRequested = 53
    IWebViewControl_RemovePermissionRequested = 54
    IWebViewControl_AddUnsupportedUriSchemeIdentified = 55
    IWebViewControl_RemoveUnsupportedUriSchemeIdentified = 56
    IWebViewControl_AddNewWindowRequested = 57
    IWebViewControl_RemoveNewWindowRequested = 58
    IWebViewControl_AddContainsFullScreenElementChanged = 59
    IWebViewControl_RemoveContainsFullScreenElementChanged = 60
    IWebViewControl_AddWebResourceRequested = 61
    IWebViewControl_RemoveWebResourceRequested = 62
                        
    ' IWebViewControl2
    IWebViewControl2_AddInitializeScript = 6
    
    ' IWebViewControlSite
    IWebViewControlSite_GetProcess = 6
    IWebViewControlSite_PutScale = 7
    IWebViewControlSite_GetScale = 8
    IWebViewControlSite_PutBounds = 9
    IWebViewControlSite_GetBounds = 10
    IWebViewControlSite_PutIsVisible = 11
    IWebViewControlSite_GetIsVisible = 12
    IWebViewControlSite_Close = 13
    IWebViewControlSite_MoveFocus = 14
    IWebViewControlSite_AddMoveFocusRequested = 15
    IWebViewControlSite_RemoveMoveFocusRequested = 16
    IWebViewControlSite_AddAcceleratorKeyPressed = 17
    IWebViewControlSite_RemoveAcceleratorKeyPressed = 18
                            
    ' IWebViewControlSite2
    IWebViewControlSite2_AddGotFocus = 6
    IWebViewControlSite2_RemoveGotFocus = 7
    IWebViewControlSite2_AddLostFocus = 8
    IWebViewControlSite2_RemoveLostFocus = 9

    ' IVectorView
    IVectorView_GetAt = 6
    IVectorView_GetSize = 7

End Enum

' ----==== Variablen ====----
Private m_pIWebViewControl As Long
Private m_pIWebViewControl2 As Long
Private m_pIWebViewControlSite As Long
Private m_pIWebViewControlSite2 As Long

Private m_pNavigationStarting As Long
Private m_pNavigationStartingToken As Long

Private m_pContentLoading As Long
Private m_pContentLoadingToken As Long

Private m_pDOMContentLoaded As Long
Private m_pDOMContentLoadedToken As Long

Private m_pNavigationCompleted As Long
Private m_pNavigationCompletedToken As Long

Private m_pFrameNavigationStarting As Long
Private m_pFrameNavigationStartingToken As Long

Private m_pFrameContentLoading As Long
Private m_pFrameContentLoadingToken As Long

Private m_pFrameDOMContentLoaded As Long
Private m_pFrameDOMContentLoadedToken As Long

Private m_pFrameNavigationCompleted As Long
Private m_pFrameNavigationCompletedToken As Long

Private m_pScriptNotify As Long
Private m_pScriptNotifyToken As Long

Private m_pLongRunningScriptDetected As Long
Private m_pLongRunningScriptDetectedToken As Long

Private m_pUnsafeContentWarningDisplaying As Long
Private m_pUnsafeContentWarningDisplayingToken As Long

Private m_pUnviewableContentIdentified As Long
Private m_pUnviewableContentIdentifiedToken As Long

Private m_pPermissionRequested As Long
Private m_pPermissionRequestedToken As Long

Private m_pUnsupportedUriSchemeIdentified As Long
Private m_pUnsupportedUriSchemeIdentifiedToken As Long

Private m_pNewWindowRequested As Long
Private m_pNewWindowRequestedToken As Long

Private m_pContainsFullScreenElementChanged As Long
Private m_pContainsFullScreenElementChangedToken As Long

Private m_pWebResourceRequested As Long
Private m_pWebResourceRequestedToken As Long

Private m_pMoveFocusRequested As Long
Private m_pMoveFocusRequestedToken As Long

Private m_pAcceleratorKeyPressed As Long
Private m_pAcceleratorKeyPressedToken As Long

Private m_pGotFocus As Long
Private m_pGotFocusToken As Long

Private m_pLostFocus As Long
Private m_pLostFocusToken As Long

' ----==== Events ====----
Public Event NavigationStarting(ByVal sender As Long, ByVal args As Long)
Public Event ContentLoading(ByVal sender As Long, ByVal args As Long)
Public Event DOMContentLoaded(ByVal sender As Long, ByVal args As Long)
Public Event NavigationCompleted(ByVal sender As Long, ByVal args As Long)
Public Event FrameNavigationStarting(ByVal sender As Long, ByVal args As Long)
Public Event FrameContentLoading(ByVal sender As Long, ByVal args As Long)
Public Event FrameDOMContentLoaded(ByVal sender As Long, ByVal args As Long)
Public Event FrameNavigationCompleted(ByVal sender As Long, ByVal args As Long)
Public Event ScriptNotify(ByVal sender As Long, ByVal args As Long)
Public Event LongRunningScriptDetected(ByVal sender As Long, ByVal args As Long)
Public Event UnsafeContentWarningDisplaying(ByVal sender As Long, ByVal args As Long)
Public Event UnviewableContentIdentified(ByVal sender As Long, ByVal args As Long)
Public Event PermissionRequested(ByVal sender As Long, ByVal args As Long)
Public Event UnsupportedUriSchemeIdentified(ByVal sender As Long, ByVal args As Long)
Public Event NewWindowRequested(ByVal sender As Long, ByVal args As Long)
Public Event ContainsFullScreenElementChanged(ByVal sender As Long, ByVal args As Long)
Public Event WebResourceRequested(ByVal sender As Long, ByVal args As Long)
Public Event MoveFocusRequested(ByVal sender As Long, ByVal args As Long)
Public Event AcceleratorKeyPressed(ByVal sender As Long, ByVal args As Long)
Public Event GotFocus(ByVal sender As Long, ByVal args As Long)
Public Event LostFocus(ByVal sender As Long, ByVal args As Long)

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()

    If m_pNavigationStartingToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveNavigationStarting, _
                    m_pNavigationStarting, m_pNavigationStartingToken)
    End If
    
    If m_pContentLoadingToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveContentLoading, _
                    m_pContentLoading, m_pContentLoadingToken)
    End If
    
    If m_pDOMContentLoadedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveDOMContentLoaded, _
                    m_pDOMContentLoaded, m_pDOMContentLoadedToken)
    End If
    
    If m_pNavigationCompletedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveNavigationCompleted, _
                    m_pNavigationCompleted, m_pNavigationCompletedToken)
    End If
    
    If m_pFrameNavigationStartingToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveFrameNavigationStarting, _
                    m_pFrameNavigationStarting, m_pFrameNavigationStartingToken)
    End If
    
    If m_pFrameContentLoadingToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveFrameContentLoading, _
                    m_pFrameContentLoading, m_pFrameContentLoadingToken)
    End If
    
    If m_pFrameDOMContentLoadedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveFrameDOMContentLoaded, _
                    m_pFrameDOMContentLoaded, m_pFrameDOMContentLoadedToken)
    End If
    
    If m_pFrameNavigationCompletedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveFrameNavigationCompleted, _
                    m_pFrameNavigationCompleted, m_pFrameNavigationCompletedToken)
    End If
    
    If m_pScriptNotifyToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveScriptNotify, _
                    m_pScriptNotify, m_pScriptNotifyToken)
    End If
    
    If m_pLongRunningScriptDetectedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveLongRunningScriptDetected, _
                    m_pLongRunningScriptDetected, m_pLongRunningScriptDetectedToken)
    End If
    
    If m_pUnsafeContentWarningDisplayingToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveUnsafeContentWarningDisplaying, _
                    m_pUnsafeContentWarningDisplaying, m_pUnsafeContentWarningDisplayingToken)
    End If
    
    If m_pUnviewableContentIdentifiedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveUnviewableContentIdentified, _
                    m_pUnviewableContentIdentified, m_pUnviewableContentIdentifiedToken)
    End If
    
    If m_pPermissionRequestedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemovePermissionRequested, _
                    m_pPermissionRequested, m_pPermissionRequestedToken)
    End If
    
    If m_pUnsupportedUriSchemeIdentifiedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveUnsupportedUriSchemeIdentified, _
                    m_pUnsupportedUriSchemeIdentified, m_pUnsupportedUriSchemeIdentifiedToken)
    End If
    
    If m_pNewWindowRequestedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveNewWindowRequested, _
                    m_pNewWindowRequested, m_pNewWindowRequestedToken)
    End If
    
    If m_pContainsFullScreenElementChangedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveContainsFullScreenElementChanged, _
                    m_pContainsFullScreenElementChanged, m_pContainsFullScreenElementChangedToken)
    End If
    
    If m_pWebResourceRequestedToken <> 0& Then
        Call Invoke(m_pIWebViewControl, IWebViewControl_RemoveWebResourceRequested, _
                    m_pWebResourceRequested, m_pWebResourceRequestedToken)
    End If
    
    If m_pMoveFocusRequestedToken <> 0& Then
        Call Invoke(m_pIWebViewControlSite, IWebViewControlSite_RemoveMoveFocusRequested, _
                    m_pMoveFocusRequested, m_pMoveFocusRequestedToken)
    End If
    
    If m_pAcceleratorKeyPressedToken <> 0& Then
        Call Invoke(m_pIWebViewControlSite, IWebViewControlSite_RemoveAcceleratorKeyPressed, _
                    m_pAcceleratorKeyPressed, m_pAcceleratorKeyPressedToken)
    End If
    
    If m_pGotFocusToken <> 0& Then
        Call Invoke(m_pIWebViewControlSite2, IWebViewControlSite2_RemoveGotFocus, _
                    m_pGotFocus, m_pGotFocusToken)
    End If
    
    If m_pLostFocusToken <> 0& Then
        Call Invoke(m_pIWebViewControlSite2, IWebViewControlSite2_RemoveLostFocus, _
                    m_pLostFocus, m_pLostFocusToken)
    End If
    
    Call ReleaseIfc(m_pIWebViewControlSite2)
    Call ReleaseIfc(m_pIWebViewControlSite)
    Call ReleaseIfc(m_pIWebViewControl2)
    Call ReleaseIfc(m_pIWebViewControl)
End Sub

' ----==== Invoke Events ====----
Public Sub Invoke_NavigationStarting(ByVal sender As Long, ByVal args As Long)
    RaiseEvent NavigationStarting(sender, args)
End Sub

Public Sub Invoke_ContentLoading(ByVal sender As Long, ByVal args As Long)
    RaiseEvent ContentLoading(sender, args)
End Sub

Public Sub Invoke_DOMContentLoaded(ByVal sender As Long, ByVal args As Long)
    RaiseEvent DOMContentLoaded(sender, args)
End Sub

Public Sub Invoke_NavigationCompleted(ByVal sender As Long, ByVal args As Long)
    RaiseEvent NavigationCompleted(sender, args)
End Sub

Public Sub Invoke_FrameNavigationStarting(ByVal sender As Long, ByVal args As Long)
    RaiseEvent FrameNavigationStarting(sender, args)
End Sub

Public Sub Invoke_FrameContentLoading(ByVal sender As Long, ByVal args As Long)
    RaiseEvent FrameContentLoading(sender, args)
End Sub

Public Sub Invoke_FrameDOMContentLoaded(ByVal sender As Long, ByVal args As Long)
    RaiseEvent FrameDOMContentLoaded(sender, args)
End Sub

Public Sub Invoke_FrameNavigationCompleted(ByVal sender As Long, ByVal args As Long)
    RaiseEvent FrameNavigationCompleted(sender, args)
End Sub

Public Sub Invoke_ScriptNotify(ByVal sender As Long, ByVal args As Long)
    RaiseEvent ScriptNotify(sender, args)
End Sub

Public Sub Invoke_LongRunningScriptDetected(ByVal sender As Long, ByVal args As Long)
    RaiseEvent LongRunningScriptDetected(sender, args)
End Sub

Public Sub Invoke_UnsafeContentWarningDisplaying(ByVal sender As Long, ByVal args As Long)
    RaiseEvent UnsafeContentWarningDisplaying(sender, args)
End Sub

Public Sub Invoke_UnviewableContentIdentified(ByVal sender As Long, ByVal args As Long)
    RaiseEvent UnviewableContentIdentified(sender, args)
End Sub

Public Sub Invoke_PermissionRequested(ByVal sender As Long, ByVal args As Long)
    RaiseEvent PermissionRequested(sender, args)
End Sub

Public Sub Invoke_UnsupportedUriSchemeIdentified(ByVal sender As Long, ByVal args As Long)
    RaiseEvent UnsupportedUriSchemeIdentified(sender, args)
End Sub

Public Sub Invoke_NewWindowRequested(ByVal sender As Long, ByVal args As Long)
    RaiseEvent NewWindowRequested(sender, args)
End Sub

Public Sub Invoke_ContainsFullScreenElementChanged(ByVal sender As Long, ByVal args As Long)
    RaiseEvent ContainsFullScreenElementChanged(sender, args)
End Sub

Public Sub Invoke_WebResourceRequested(ByVal sender As Long, ByVal args As Long)
    RaiseEvent WebResourceRequested(sender, args)
End Sub

Public Sub Invoke_MoveFocusRequested(ByVal sender As Long, ByVal args As Long)
    RaiseEvent MoveFocusRequested(sender, args)
End Sub

Public Sub Invoke_AcceleratorKeyPressed(ByVal sender As Long, ByVal args As Long)
    RaiseEvent AcceleratorKeyPressed(sender, args)
End Sub

Public Sub Invoke_GotFocus(ByVal sender As Long, ByVal args As Long)
    RaiseEvent GotFocus(sender, args)
End Sub

Public Sub Invoke_LostFocus(ByVal sender As Long, ByVal args As Long)
    RaiseEvent LostFocus(sender, args)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControl(ByVal pIWebViewControl As Long)
    Call ReleaseIfc(m_pIWebViewControlSite2)
    Call ReleaseIfc(m_pIWebViewControlSite)
    Call ReleaseIfc(m_pIWebViewControl2)
    Call ReleaseIfc(m_pIWebViewControl)
    m_pIWebViewControl = pIWebViewControl
    If m_pIWebViewControl <> 0& Then
        Call QueryIfc(m_pIWebViewControl, IID_IWebViewControl2, m_pIWebViewControl2)
        Call QueryIfc(m_pIWebViewControl, IID_IWebViewControlSite, m_pIWebViewControlSite)
        Call QueryIfc(m_pIWebViewControl, IID_IWebViewControlSite2, m_pIWebViewControlSite2)
        
        m_pNavigationStarting = modITEH_NavigationStarting.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddNavigationStarting, _
                    m_pNavigationStarting, VarPtr(m_pNavigationStartingToken))

        m_pContentLoading = modITEH_ContentLoading.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddContentLoading, _
                    m_pContentLoading, VarPtr(m_pContentLoadingToken))

        m_pDOMContentLoaded = modITEH_DOMContentLoaded.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddDOMContentLoaded, _
                    m_pDOMContentLoaded, VarPtr(m_pDOMContentLoadedToken))

        m_pNavigationCompleted = modITEH_NavigationCompleted.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddNavigationCompleted, _
                    m_pNavigationCompleted, VarPtr(m_pNavigationCompletedToken))

        m_pFrameNavigationStarting = modITEH_FrameNavigationStarting.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddFrameNavigationStarting, _
                    m_pFrameNavigationStarting, VarPtr(m_pFrameNavigationStartingToken))

        m_pFrameContentLoading = modITEH_FrameContentLoading.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddFrameContentLoading, _
                    m_pFrameContentLoading, VarPtr(m_pFrameContentLoadingToken))

        m_pFrameDOMContentLoaded = modITEH_FrameDOMContentLoaded.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddFrameDOMContentLoaded, _
                    m_pFrameDOMContentLoaded, VarPtr(m_pFrameDOMContentLoadedToken))

        m_pFrameNavigationCompleted = modITEH_FrameNavigationCompleted.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddFrameNavigationCompleted, _
                    m_pFrameNavigationCompleted, VarPtr(m_pFrameNavigationCompletedToken))

        m_pScriptNotify = modITEH_ScriptNotify.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddScriptNotify, _
                    m_pScriptNotify, VarPtr(m_pScriptNotifyToken))

        m_pLongRunningScriptDetected = modITEH_LongRunningScriptDetected.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddLongRunningScriptDetected, _
                    m_pLongRunningScriptDetected, VarPtr(m_pLongRunningScriptDetectedToken))

        m_pUnsafeContentWarningDisplaying = modITEH_UnsafeContentWarningDisplaying.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddUnsafeContentWarningDisplaying, _
                    m_pUnsafeContentWarningDisplaying, VarPtr(m_pUnsafeContentWarningDisplayingToken))

        m_pUnviewableContentIdentified = modITEH_UnviewableContentIdentified.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddUnviewableContentIdentified, _
                    m_pUnviewableContentIdentified, VarPtr(m_pUnviewableContentIdentifiedToken))

        m_pPermissionRequested = modITEH_PermissionRequested.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddPermissionRequested, _
                    m_pPermissionRequested, VarPtr(m_pPermissionRequestedToken))

        m_pUnsupportedUriSchemeIdentified = modITEH_UnsupportedUriSchemeIdentified.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddUnsupportedUriSchemeIdentified, _
                    m_pUnsupportedUriSchemeIdentified, VarPtr(m_pUnsupportedUriSchemeIdentifiedToken))

        m_pContainsFullScreenElementChanged = modITEH_ContainsFullScreenElementChanged.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddContainsFullScreenElementChanged, _
                    m_pContainsFullScreenElementChanged, VarPtr(m_pContainsFullScreenElementChangedToken))

        m_pWebResourceRequested = modITEH_WebResourceRequested.Create(Me)
        Call Invoke(m_pIWebViewControl, IWebViewControl_AddWebResourceRequested, _
                    m_pWebResourceRequested, VarPtr(m_pWebResourceRequestedToken))

        m_pMoveFocusRequested = modITEH_MoveFocusRequested.Create(Me)
        Call Invoke(m_pIWebViewControlSite, IWebViewControlSite_AddMoveFocusRequested, _
                    m_pMoveFocusRequested, VarPtr(m_pMoveFocusRequestedToken))

        m_pAcceleratorKeyPressed = modITEH_AcceleratorKeyPressed.Create(Me)
        Call Invoke(m_pIWebViewControlSite, IWebViewControlSite_AddAcceleratorKeyPressed, _
                    m_pAcceleratorKeyPressed, VarPtr(m_pAcceleratorKeyPressedToken))

        m_pGotFocus = modITEH_GotFocus.Create(Me)
        Call Invoke(m_pIWebViewControlSite2, IWebViewControlSite2_AddGotFocus, _
                    m_pGotFocus, VarPtr(m_pGotFocusToken))

        m_pLostFocus = modITEH_LostFocus.Create(Me)
        Call Invoke(m_pIWebViewControlSite2, IWebViewControlSite2_AddLostFocus, _
                    m_pLostFocus, VarPtr(m_pLostFocusToken))
    
    End If
End Property

Public Property Get IWebViewControl() As Long
    IWebViewControl = m_pIWebViewControl
End Property

' IWebViewControl
Public Property Get Source() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControl <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetSource, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Source = Ret
End Property

Public Property Let Source(ByVal UriRuntimeClass As clsURC)
    If m_pIWebViewControl <> 0& And _
       UriRuntimeClass.IUriRuntimeClass <> 0& Then
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_PutSource, _
                  UriRuntimeClass.IUriRuntimeClass) = S_OK Then
        End If
    End If
End Property

Public Property Get DocumentTitle() As String
    Dim Ret As String
    If m_pIWebViewControl <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetDocumentTitle, _
                  VarPtr(value)) = S_OK Then
            Ret = GetWindowsString(value)
        End If
    End If
    DocumentTitle = Ret
End Property

Public Property Get CanGoBack() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetCanGoBack, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    CanGoBack = Ret
End Property

Public Property Get CanGoForward() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetCanGoForward, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    CanGoForward = Ret
End Property

Friend Property Let DefaultBackgroundColor(ByRef value As Color)
    If m_pIWebViewControl <> 0& Then
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_PutDefaultBackgroundColor, _
                  Color2Long(value)) = S_OK Then
            Me.Refresh
        End If
    End If
End Property

Friend Property Get DefaultBackgroundColor() As Color
    Dim Ret As Color
    If m_pIWebViewControl <> 0& Then
        Dim value As Color
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetDefaultBackgroundColor, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    DefaultBackgroundColor = Ret
End Property

Public Property Get ContainsFullScreenElement() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetContainsFullScreenElement, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    ContainsFullScreenElement = Ret
End Property

Public Property Get Settings() As clsWVCS
    Dim Ret As New clsWVCS
    If m_pIWebViewControl <> 0& Then
        Dim pIWebViewControlSettings As Long
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetSettings, _
                  VarPtr(pIWebViewControlSettings)) = S_OK Then
            Ret.IWebViewControlSettings = pIWebViewControlSettings
        End If
    End If
    Set Settings = Ret
End Property

Public Property Get DeferredPermissionRequestsCount() As Long
    Dim Ret As Long
    If m_pIWebViewControl <> 0& Then
        Dim pIVectorView As Long
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetDeferredPermissionRequests, _
                  VarPtr(pIVectorView)) = S_OK Then
            If pIVectorView <> 0& Then
                Dim value As Long
                If Invoke(pIVectorView, _
                          IVectorView_GetSize, _
                          VarPtr(value)) = S_OK Then
                    Ret = value
                End If
                Call ReleaseIfc(pIVectorView)
            End If
        End If
    End If
    DeferredPermissionRequestsCount = Ret
End Property

Public Property Get DeferredPermissionRequests() As clsWVCDPR()
    Dim Ret() As clsWVCDPR
    If m_pIWebViewControl <> 0& Then
        Dim pIVectorView As Long
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GetDeferredPermissionRequests, _
                  VarPtr(pIVectorView)) = S_OK Then
            If pIVectorView <> 0& Then
                Dim count As Long
                If Invoke(pIVectorView, _
                          IVectorView_GetSize, _
                          VarPtr(count)) = S_OK Then
                    If count > 0& Then
                        Dim item As Long
                        ReDim Ret(count - 1)
                        For item = 0 To count - 1
                        Dim pIWebViewControlDeferredPermissionRequest As Long
                            If Invoke(pIVectorView, _
                                      IVectorView_GetAt, _
                                      item, _
                                      VarPtr(pIWebViewControlDeferredPermissionRequest)) = S_OK Then
                                If pIWebViewControlDeferredPermissionRequest <> 0& Then
                                    Set Ret(item) = New clsWVCDPR
                                    Ret(item).IWebViewControlDeferredPermissionRequest = pIWebViewControlDeferredPermissionRequest
                                End If
                            End If
                        Next
                    End If
                End If
                Call ReleaseIfc(pIVectorView)
            End If
        End If
    End If
    DeferredPermissionRequests = Ret
End Property

' IWebViewControlSite
Public Property Get Process() As clsWVCP
    Dim Ret As New clsWVCP
        If m_pIWebViewControlSite <> 0& Then
            Dim pIWebViewControlProcess As Long
            If Invoke(m_pIWebViewControlSite, _
                      IWebViewControlSite_GetProcess, _
                      VarPtr(pIWebViewControlProcess)) = S_OK Then
                Ret.IWebViewControlProcess = pIWebViewControlProcess
            End If
        End If
    Set Process = Ret
End Property

Public Property Let Scaling(ByVal value As Double)
    If m_pIWebViewControlSite <> 0& Then
        If Invoke(m_pIWebViewControlSite, _
                  IWebViewControlSite_PutScale, _
                  value) = S_OK Then
        End If
    End If
End Property

Public Property Get Scaling() As Double
    Dim Ret As Double
    If m_pIWebViewControlSite <> 0& Then
        Dim value As Double
        If Invoke(m_pIWebViewControlSite, _
                  IWebViewControlSite_GetScale, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    Scaling = Ret
End Property

Friend Property Let bounds(ByRef value As Rect)
    If m_pIWebViewControlSite <> 0& Then
        If Invoke(m_pIWebViewControlSite, _
                  IWebViewControlSite_PutBounds, _
                  value.X, value.Y, _
                  value.Width, value.Height) = S_OK Then
        End If
    End If
End Property

Friend Property Get bounds() As Rect
    Dim Ret As Rect
    If m_pIWebViewControlSite <> 0& Then
        Dim value As Rect
        If Invoke(m_pIWebViewControlSite, _
                  IWebViewControlSite_GetBounds, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    bounds = Ret
End Property

Public Property Let IsVisible(ByVal value As Boolean)
    If m_pIWebViewControlSite <> 0& Then
        If Invoke(m_pIWebViewControlSite, _
                  IWebViewControlSite_PutIsVisible, _
                  value) = S_OK Then
        End If
    End If
End Property

Public Property Get IsVisible() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlSite <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlSite, _
                  IWebViewControlSite_GetIsVisible, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    IsVisible = Ret
End Property

' ----==== Functions ====----
' IWebViewControl
Public Function GoForward() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& Then
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GoForward) = S_OK Then
            Ret = True
        End If
    End If
    GoForward = Ret
End Function

Public Function GoBack() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& Then
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_GoBack) = S_OK Then
            Ret = True
        End If
    End If
    GoBack = Ret
End Function

Public Function Refresh() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& Then
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_Refresh) = S_OK Then
            Ret = True
        End If
    End If
    Refresh = Ret
End Function

Public Function Stopping() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& Then
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_Stop) = S_OK Then
            Ret = True
        End If
    End If
    Stopping = Ret
End Function

Public Function Navigate(ByVal UriRuntimeClass As clsURC) As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& And _
       UriRuntimeClass.IUriRuntimeClass <> 0& Then
        If Invoke(m_pIWebViewControl, _
                  IWebViewControl_Navigate, _
                  UriRuntimeClass.IUriRuntimeClass) = S_OK Then
            Ret = True
        End If
    End If
    Navigate = Ret
End Function

Public Function NavigateToString(ByVal text As String) As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(text)
        If hString <> 0& Then
            If Invoke(m_pIWebViewControl, _
                      IWebViewControl_NavigateToString, _
                      hString) = S_OK Then
                Ret = True
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    NavigateToString = Ret
End Function

'    IWebViewControl_NavigateToLocalStreamUri = 22
'    IWebViewControl_NavigateWithHttpRequestMessage = 23

' arguments = IIterable_1_HSTRING
Public Function InvokeScriptAsync(ByVal scriptName As String, _
                                  ByVal arguments As Long) As String
    Dim Ret As String
    If m_pIWebViewControl <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(scriptName)
        If hString <> 0& Then
            Dim pIAsyncOperation_HSTRING As Long
            If Invoke(m_pIWebViewControl, _
                      IWebViewControl_InvokeScriptAsync, _
                      hString, _
                      arguments, _
                      VarPtr(pIAsyncOperation_HSTRING)) = S_OK Then
                If Await(pIAsyncOperation_HSTRING) Then
                    Ret = GetWindowsString(pIAsyncOperation_HSTRING)
                End If
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    InvokeScriptAsync = Ret
End Function

'    IWebViewControl_CapturePreviewToStreamAsync = 25
'    IWebViewControl_CaptureSelectedContentToDataPackageAsync = 26
'    IWebViewControl_BuildLocalStreamUri = 27

Public Property Get GetDeferredPermissionRequestById(ByVal Id As Long) As clsWVCDPR
    Dim Ret As New clsWVCDPR
        If m_pIWebViewControl <> 0& Then
            Dim pIWebViewControlDeferredPermissionRequest As Long
            If Invoke(m_pIWebViewControl, _
                      IWebViewControl_GetDeferredPermissionRequestById, _
                      Id, _
                      VarPtr(pIWebViewControlDeferredPermissionRequest)) = S_OK Then
                Ret.IWebViewControlDeferredPermissionRequest = pIWebViewControlDeferredPermissionRequest
            End If
        End If
    Set GetDeferredPermissionRequestById = Ret
End Property

' IWebViewControl2
Public Function AddInitializeScript(ByVal script As String) As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControl2 <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(script)
        If hString <> 0& Then
            If Invoke(m_pIWebViewControl2, _
                      IWebViewControl2_AddInitializeScript, _
                      hString) = S_OK Then
                Ret = True
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    AddInitializeScript = Ret
End Function

' IWebViewControlSite
Public Function Closing() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlSite <> 0& Then
        Dim value As Double
        If Invoke(m_pIWebViewControlSite, _
                  IWebViewControlSite_Close) = S_OK Then
            Ret = True
        End If
    End If
    Closing = Ret
End Function

Public Function MoveFocus(ByVal Reason As WebViewControlMoveFocusReason) As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlSite <> 0& Then
        Dim value As Double
        If Invoke(m_pIWebViewControlSite, _
                  IWebViewControlSite_MoveFocus, _
                  Reason) = S_OK Then
            Ret = True
        End If
    End If
    MoveFocus = Ret
End Function

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function
