VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCAKPEA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlAcceleratorKeyPressedEventArgs As String = "{77a2a53e-7c74-437d-a290-3ac0d8cd5655}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlAcceleratorKeyPressedEventArgs
    IWebViewControlAcceleratorKeyPressedEventArgs_GetEventType = 6
    IWebViewControlAcceleratorKeyPressedEventArgs_GetVirtualKey = 7
    IWebViewControlAcceleratorKeyPressedEventArgs_GetKeyStatus = 8
    IWebViewControlAcceleratorKeyPressedEventArgs_GetRoutingStage = 9
    IWebViewControlAcceleratorKeyPressedEventArgs_GetHandled = 10
    IWebViewControlAcceleratorKeyPressedEventArgs_PutHandled = 11
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlAcceleratorKeyPressedEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlAcceleratorKeyPressedEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlAcceleratorKeyPressedEventArgs(ByVal pIWebViewControlAcceleratorKeyPressedEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlAcceleratorKeyPressedEventArgs)
    m_pIWebViewControlAcceleratorKeyPressedEventArgs = pIWebViewControlAcceleratorKeyPressedEventArgs
End Property

Public Property Get IWebViewControlAcceleratorKeyPressedEventArgs() As Long
    IWebViewControlAcceleratorKeyPressedEventArgs = m_pIWebViewControlAcceleratorKeyPressedEventArgs
End Property

' IWebViewControlAcceleratorKeyPressedEventArgs
Public Property Get EventType() As CoreAcceleratorKeyEventType
    Dim Ret As CoreAcceleratorKeyEventType
    If m_pIWebViewControlAcceleratorKeyPressedEventArgs <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlAcceleratorKeyPressedEventArgs, _
                  IWebViewControlAcceleratorKeyPressedEventArgs_GetEventType, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    EventType = Ret
End Property

Public Property Get VirtualKey() As VirtualKey
    Dim Ret As VirtualKey
    If m_pIWebViewControlAcceleratorKeyPressedEventArgs <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlAcceleratorKeyPressedEventArgs, _
                  IWebViewControlAcceleratorKeyPressedEventArgs_GetVirtualKey, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    VirtualKey = Ret
End Property

Friend Property Get KeyStatus() As CorePhysicalKeyStatus
    Dim Ret As CorePhysicalKeyStatus
    If m_pIWebViewControlAcceleratorKeyPressedEventArgs <> 0& Then
        Dim value As CorePhysicalKeyStatus
        If Invoke(m_pIWebViewControlAcceleratorKeyPressedEventArgs, _
                  IWebViewControlAcceleratorKeyPressedEventArgs_GetKeyStatus, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    KeyStatus = Ret
End Property

Public Property Get RoutingStage() As WebViewControlAcceleratorKeyRoutingStage
    Dim Ret As WebViewControlAcceleratorKeyRoutingStage
    If m_pIWebViewControlAcceleratorKeyPressedEventArgs <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlAcceleratorKeyPressedEventArgs, _
                  IWebViewControlAcceleratorKeyPressedEventArgs_GetRoutingStage, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    RoutingStage = Ret
End Property

Public Property Get Handled() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlAcceleratorKeyPressedEventArgs <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlAcceleratorKeyPressedEventArgs, _
                  IWebViewControlAcceleratorKeyPressedEventArgs_GetHandled, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    Handled = Ret
End Property

Public Property Let Handled(ByVal value As Boolean)
    If m_pIWebViewControlAcceleratorKeyPressedEventArgs <> 0& Then
        If Invoke(m_pIWebViewControlAcceleratorKeyPressedEventArgs, _
                  IWebViewControlAcceleratorKeyPressedEventArgs_PutHandled, _
                  value) = S_OK Then
        End If
    End If
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


