VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCDPR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlDeferredPermissionRequest As String = "{2ce349e0-d759-445c-9926-8995298f152b}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlDeferredPermissionRequest
    IWebViewControlDeferredPermissionRequest_GetId = 6
    IWebViewControlDeferredPermissionRequest_GetUri = 7
    IWebViewControlDeferredPermissionRequest_GetPermissionType = 8
    IWebViewControlDeferredPermissionRequest_Allow = 9
    IWebViewControlDeferredPermissionRequest_Deny = 10
   
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlDeferredPermissionRequest As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlDeferredPermissionRequest)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlDeferredPermissionRequest(ByVal pIWebViewControlDeferredPermissionRequest As Long)
    Call ReleaseIfc(m_pIWebViewControlDeferredPermissionRequest)
    m_pIWebViewControlDeferredPermissionRequest = pIWebViewControlDeferredPermissionRequest
End Property

Public Property Get IWebViewControlDeferredPermissionRequest() As Long
    IWebViewControlDeferredPermissionRequest = m_pIWebViewControlDeferredPermissionRequest
End Property

' IWebViewControlDeferredPermissionRequest
Public Property Get Id() As Long
    Dim Ret As Long
    If m_pIWebViewControlDeferredPermissionRequest <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlDeferredPermissionRequest, _
                  IWebViewControlDeferredPermissionRequest_GetId, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    Id = Ret
End Property

Public Property Get Uri() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlDeferredPermissionRequest <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlDeferredPermissionRequest, _
                  IWebViewControlDeferredPermissionRequest_GetUri, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Uri = Ret
End Property

Public Property Get PermissionType() As WebViewControlPermissionType
    Dim Ret As WebViewControlPermissionType
    If m_pIWebViewControlDeferredPermissionRequest <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlDeferredPermissionRequest, _
                  IWebViewControlDeferredPermissionRequest_GetPermissionType, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    PermissionType = Ret
End Property

' ----==== Functions ====----
' IWebViewControlDeferredPermissionRequest
Public Function Allow() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlDeferredPermissionRequest <> 0& Then
        If Invoke(m_pIWebViewControlDeferredPermissionRequest, _
                  IWebViewControlDeferredPermissionRequest_Allow) = S_OK Then
            Ret = True
        End If
    End If
    Allow = Ret
End Function

Public Function Deny() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlDeferredPermissionRequest <> 0& Then
        If Invoke(m_pIWebViewControlDeferredPermissionRequest, _
                  IWebViewControlDeferredPermissionRequest_Deny) = S_OK Then
            Ret = True
        End If
    End If
    Deny = Ret
End Function

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


