VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCLRSDEA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlLongRunningScriptDetectedEventArgs As String = "{2a6e5bba-98b4-45bc-bbeb-0f69ce49c599}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlLongRunningScriptDetectedEventArgs
    IWebViewControlLongRunningScriptDetectedEventArgs_GetExecutionTime = 6
    IWebViewControlLongRunningScriptDetectedEventArgs_GetStopPageScriptExecution = 7
    IWebViewControlLongRunningScriptDetectedEventArgs_PutStopPageScriptExecution = 8
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlLongRunningScriptDetectedEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlLongRunningScriptDetectedEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlLongRunningScriptDetectedEventArgs(ByVal pIWebViewControlLongRunningScriptDetectedEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlLongRunningScriptDetectedEventArgs)
    m_pIWebViewControlLongRunningScriptDetectedEventArgs = pIWebViewControlLongRunningScriptDetectedEventArgs
End Property

Public Property Get IWebViewControlLongRunningScriptDetectedEventArgs() As Long
    IWebViewControlLongRunningScriptDetectedEventArgs = m_pIWebViewControlLongRunningScriptDetectedEventArgs
End Property

' IWebViewControlLongRunningScriptDetectedEventArgs
Public Property Get ExecutionTime() As Currency
    Dim Ret As Currency
    If m_pIWebViewControlLongRunningScriptDetectedEventArgs <> 0& Then
        Dim value As Currency
        If Invoke(m_pIWebViewControlLongRunningScriptDetectedEventArgs, _
                  IWebViewControlLongRunningScriptDetectedEventArgs_GetExecutionTime, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    ExecutionTime = Ret ' as TimeSpan
End Property

Public Property Get StopPageScriptExecution() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlLongRunningScriptDetectedEventArgs <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlLongRunningScriptDetectedEventArgs, _
                  IWebViewControlLongRunningScriptDetectedEventArgs_GetStopPageScriptExecution, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    StopPageScriptExecution = Ret
End Property

Public Property Let StopPageScriptExecution(ByVal value As Boolean)
    If m_pIWebViewControlLongRunningScriptDetectedEventArgs <> 0& Then
        If Invoke(m_pIWebViewControlLongRunningScriptDetectedEventArgs, _
                  IWebViewControlLongRunningScriptDetectedEventArgs_PutStopPageScriptExecution, _
                  value) = S_OK Then
        End If
    End If
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


