VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCNCEA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlNavigationCompletedEventArgs As String = "{20409918-4a15-4c46-a55d-f79edb0bde8b}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlNavigationCompletedEventArgs
    IWebViewControlNavigationCompletedEventArgs_GetUri = 6
    IWebViewControlNavigationCompletedEventArgs_GetIsSuccess = 7
    IWebViewControlNavigationCompletedEventArgs_GetWebErrorStatus = 8
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlNavigationCompletedEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlNavigationCompletedEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlNavigationCompletedEventArgs(ByVal pIWebViewControlNavigationCompletedEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlNavigationCompletedEventArgs)
    m_pIWebViewControlNavigationCompletedEventArgs = pIWebViewControlNavigationCompletedEventArgs
End Property

Public Property Get IWebViewControlNavigationCompletedEventArgs() As Long
    IWebViewControlNavigationCompletedEventArgs = m_pIWebViewControlNavigationCompletedEventArgs
End Property

' IWebViewControlNavigationCompletedEventArgs
Public Property Get Uri() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlNavigationCompletedEventArgs <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlNavigationCompletedEventArgs, _
                  IWebViewControlNavigationCompletedEventArgs_GetUri, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Uri = Ret
End Property

Public Property Get IsSuccess() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlNavigationCompletedEventArgs <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlNavigationCompletedEventArgs, _
                  IWebViewControlNavigationCompletedEventArgs_GetIsSuccess, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    IsSuccess = Ret
End Property

Public Property Get WebErrorStatus() As WebErrorStatus
    Dim Ret As WebErrorStatus
    If m_pIWebViewControlNavigationCompletedEventArgs <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlNavigationCompletedEventArgs, _
                  IWebViewControlNavigationCompletedEventArgs_GetWebErrorStatus, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    WebErrorStatus = Ret
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


