VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCNWREA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlNewWindowRequestedEventArgs As String = "{3df44bbb-a124-46d5-a083-d02cacdff5ad}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlNewWindowRequestedEventArgs
    IWebViewControlNewWindowRequestedEventArgs_GetUri = 6
    IWebViewControlNewWindowRequestedEventArgs_GetReferrer = 7
    IWebViewControlNewWindowRequestedEventArgs_GetHandled = 8
    IWebViewControlNewWindowRequestedEventArgs_PutHandled = 9
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlNewWindowRequestedEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlNewWindowRequestedEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlNewWindowRequestedEventArgs(ByVal pIWebViewControlNewWindowRequestedEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlNewWindowRequestedEventArgs)
    m_pIWebViewControlNewWindowRequestedEventArgs = pIWebViewControlNewWindowRequestedEventArgs
End Property

Public Property Get IWebViewControlNewWindowRequestedEventArgs() As Long
    IWebViewControlNewWindowRequestedEventArgs = m_pIWebViewControlNewWindowRequestedEventArgs
End Property

' IWebViewControlNewWindowRequestedEventArgs
Public Property Get Uri() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlNewWindowRequestedEventArgs <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlNewWindowRequestedEventArgs, _
                  IWebViewControlNewWindowRequestedEventArgs_GetUri, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Uri = Ret
End Property

Public Property Get Referrer() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlNewWindowRequestedEventArgs <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlNewWindowRequestedEventArgs, _
                  IWebViewControlNewWindowRequestedEventArgs_GetReferrer, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Referrer = Ret
End Property

Public Property Get Handled() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlNewWindowRequestedEventArgs <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlNewWindowRequestedEventArgs, _
                  IWebViewControlNewWindowRequestedEventArgs_GetHandled, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    Handled = Ret
End Property

Public Property Let Handled(ByVal value As Boolean)
    If m_pIWebViewControlNewWindowRequestedEventArgs <> 0& Then
        If Invoke(m_pIWebViewControlNewWindowRequestedEventArgs, _
                  IWebViewControlNewWindowRequestedEventArgs_PutHandled, _
                  value) = S_OK Then
        End If
    End If
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


