VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCPR"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlPermissionRequest As String = "{e5bc836c-f22f-40e2-95b2-7729f840eb7f}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlPermissionRequest
    IWebViewControlPermissionRequest_GetId = 6
    IWebViewControlPermissionRequest_GetUri = 7
    IWebViewControlPermissionRequest_GetPermissionType = 8
    IWebViewControlPermissionRequest_GetState = 9
    IWebViewControlPermissionRequest_Defer = 10
    IWebViewControlPermissionRequest_Allow = 11
    IWebViewControlPermissionRequest_Deny = 12
   
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlPermissionRequest As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlPermissionRequest)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlPermissionRequest(ByVal pIWebViewControlPermissionRequest As Long)
    Call ReleaseIfc(m_pIWebViewControlPermissionRequest)
    m_pIWebViewControlPermissionRequest = pIWebViewControlPermissionRequest
End Property

Public Property Get IWebViewControlPermissionRequest() As Long
    IWebViewControlPermissionRequest = m_pIWebViewControlPermissionRequest
End Property

' IWebViewControlPermissionRequest
Public Property Get Id() As Long
    Dim Ret As Long
    If m_pIWebViewControlPermissionRequest <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlPermissionRequest, _
                  IWebViewControlPermissionRequest_GetId, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    Id = Ret
End Property

Public Property Get Uri() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlPermissionRequest <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlPermissionRequest, _
                  IWebViewControlPermissionRequest_GetUri, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Uri = Ret
End Property

Public Property Get PermissionType() As WebViewControlPermissionType
    Dim Ret As WebViewControlPermissionType
    If m_pIWebViewControlPermissionRequest <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlPermissionRequest, _
                  IWebViewControlPermissionRequest_GetPermissionType, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    PermissionType = Ret
End Property

Public Property Get State() As WebViewControlPermissionState
    Dim Ret As WebViewControlPermissionState
    If m_pIWebViewControlPermissionRequest <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlPermissionRequest, _
                  IWebViewControlPermissionRequest_GetState, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    State = Ret
End Property

' ----==== Functions ====----
' IWebViewControlPermissionRequest
Public Function Defer() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlPermissionRequest <> 0& Then
        If Invoke(m_pIWebViewControlPermissionRequest, _
                  IWebViewControlPermissionRequest_Defer) = S_OK Then
            Ret = True
        End If
    End If
    Defer = Ret
End Function

Public Function Allow() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlPermissionRequest <> 0& Then
        If Invoke(m_pIWebViewControlPermissionRequest, _
                  IWebViewControlPermissionRequest_Allow) = S_OK Then
            Ret = True
        End If
    End If
    Allow = Ret
End Function

Public Function Deny() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlPermissionRequest <> 0& Then
        If Invoke(m_pIWebViewControlPermissionRequest, _
                  IWebViewControlPermissionRequest_Deny) = S_OK Then
            Ret = True
        End If
    End If
    Deny = Ret
End Function

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


