VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCPREA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlPermissionRequestedEventArgs As String = "{27204d51-2488-4cc5-968e-0a771e59c147}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlPermissionRequestedEventArgs
    IWebViewControlPermissionRequestedEventArgs_GetPermissionRequest = 6
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlPermissionRequestedEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlPermissionRequestedEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlPermissionRequestedEventArgs(ByVal pIWebViewControlPermissionRequestedEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlPermissionRequestedEventArgs)
    m_pIWebViewControlPermissionRequestedEventArgs = pIWebViewControlPermissionRequestedEventArgs
End Property

Public Property Get IWebViewControlPermissionRequestedEventArgs() As Long
    IWebViewControlPermissionRequestedEventArgs = m_pIWebViewControlPermissionRequestedEventArgs
End Property

' IWebViewControlPermissionRequestedEventArgs
Public Property Get PermissionRequest() As clsWVCPR
    Dim Ret As New clsWVCPR
    If m_pIWebViewControlPermissionRequestedEventArgs <> 0& Then
        Dim pIWebViewControlPermissionRequest As Long
        If Invoke(m_pIWebViewControlPermissionRequestedEventArgs, _
                  IWebViewControlPermissionRequestedEventArgs_GetPermissionRequest, _
                  VarPtr(pIWebViewControlPermissionRequest)) = S_OK Then
            Ret.IWebViewControlPermissionRequest = pIWebViewControlPermissionRequest
        End If
    End If
    Set PermissionRequest = Ret
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


