VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCPO"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsWebUIInteropWebViewControlProcessOptions As String = "Windows.Web.UI.Interop.WebViewControlProcessOptions"
Private Const IID_IWebViewControlProcessOptions As String = "{1cca72a7-3bd6-4826-8261-6c8189505d89}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlProcessOptions
    IWebViewControlProcessOptions_PutEnterpriseId = 6
    IWebViewControlProcessOptions_GetEnterpriseId = 7
    IWebViewControlProcessOptions_PutPrivateNetworkClientServerCapability = 8
    IWebViewControlProcessOptions_GetPrivateNetworkClientServerCapability = 9

End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlProcessOptions As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    If GetActivateInstance(WindowsWebUIInteropWebViewControlProcessOptions, _
                           IID_IWebViewControlProcessOptions, _
                           m_pIWebViewControlProcessOptions) Then
    End If
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlProcessOptions)
End Sub

' ----==== Properties ====----
Public Property Get IWebViewControlProcessOptions() As Long
    IWebViewControlProcessOptions = m_pIWebViewControlProcessOptions
End Property

Public Property Let EnterpriseId(value As String)
    If m_pIWebViewControlProcessOptions <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(value)
        If hString <> 0& Then
            If Invoke(m_pIWebViewControlProcessOptions, _
                      IWebViewControlProcessOptions_PutEnterpriseId, _
                      hString) = S_OK Then
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
End Property

Public Property Get EnterpriseId() As String
    Dim Ret As String
    If m_pIWebViewControlProcessOptions <> 0& Then
        Dim hString As Long
        If Invoke(m_pIWebViewControlProcessOptions, _
                  IWebViewControlProcessOptions_GetEnterpriseId, _
                  hString) = S_OK Then
            Ret = GetWindowsString(hString)
        End If
    End If
    EnterpriseId = Ret
End Property
    
Public Property Let PrivateNetworkClientServerCapability(value As WebViewControlProcessCapabilityState)
    If m_pIWebViewControlProcessOptions <> 0& Then
        If Invoke(m_pIWebViewControlProcessOptions, _
                  IWebViewControlProcessOptions_PutPrivateNetworkClientServerCapability, _
                  value) = S_OK Then
        End If
    End If
End Property

Public Property Get PrivateNetworkClientServerCapability() As WebViewControlProcessCapabilityState
    Dim Ret As WebViewControlProcessCapabilityState
    If m_pIWebViewControlProcessOptions <> 0& Then
        Dim value As Long
        If Invoke(m_pIWebViewControlProcessOptions, _
                  IWebViewControlProcessOptions_GetPrivateNetworkClientServerCapability, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    EnterpriseId = Ret
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

