VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCSNEA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlScriptNotifyEventArgs As String = "{491de57b-6f49-41bb-b591-51b85b817037}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlScriptNotifyEventArgs
    IWebViewControlScriptNotifyEventArgs_GetUri = 6
    IWebViewControlScriptNotifyEventArgs_GetValue = 7
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlScriptNotifyEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlScriptNotifyEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlScriptNotifyEventArgs(ByVal pIWebViewControlScriptNotifyEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlScriptNotifyEventArgs)
    m_pIWebViewControlScriptNotifyEventArgs = pIWebViewControlScriptNotifyEventArgs
End Property

Public Property Get IWebViewControlScriptNotifyEventArgs() As Long
    IWebViewControlScriptNotifyEventArgs = m_pIWebViewControlScriptNotifyEventArgs
End Property

' IWebViewControlScriptNotifyEventArgs
Public Property Get Uri() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlScriptNotifyEventArgs <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlScriptNotifyEventArgs, _
                  IWebViewControlScriptNotifyEventArgs_GetUri, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Uri = Ret
End Property

Public Property Get value() As String
    Dim Ret As String
    If m_pIWebViewControlScriptNotifyEventArgs <> 0& Then
        Dim hString As Long
        If Invoke(m_pIWebViewControlScriptNotifyEventArgs, _
                  IWebViewControlScriptNotifyEventArgs_GetValue, _
                  VarPtr(hString)) = S_OK Then
            Ret = GetWindowsString(hString)
        End If
    End If
    value = Ret
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


