VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsWebUIWebViewControlSettings As String = "Windows.Web.UI.WebViewControlSettings"
Private Const IID_IWebViewControlSettings As String = "{c9967fbf-5e98-4cfd-8cce-27b0911e3de8}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlSettings
    IWebViewControlSettings_PutIsJavaScriptEnabled = 6
    IWebViewControlSettings_GetIsJavaScriptEnabled = 7
    IWebViewControlSettings_PutIsIndexedDBEnabled = 8
    IWebViewControlSettings_GetIsIndexedDBEnabled = 9
    IWebViewControlSettings_PutIsScriptNotifyAllowed = 10
    IWebViewControlSettings_GetIsScriptNotifyAllowed = 11

End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlSettings As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlSettings)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlSettings(ByVal pIWebViewControlSettings As Long)
    Call ReleaseIfc(m_pIWebViewControlSettings)
    m_pIWebViewControlSettings = pIWebViewControlSettings
End Property

Public Property Get IWebViewControlSettings() As Long
    IWebViewControlSettings = m_pIWebViewControlSettings
End Property

Public Property Let IsJavaScriptEnabled(ByVal value As Boolean)
    If m_pIWebViewControlSettings <> 0& Then
        If Invoke(m_pIWebViewControlSettings, _
                  IWebViewControlSettings_PutIsJavaScriptEnabled, _
                  value) = S_OK Then
        End If
    End If
End Property

Public Property Get IsJavaScriptEnabled() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlSettings <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlSettings, _
                  IWebViewControlSettings_GetIsJavaScriptEnabled, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    IsJavaScriptEnabled = Ret
End Property

Public Property Let IsIndexedDBEnabled(ByVal value As Boolean)
    If m_pIWebViewControlSettings <> 0& Then
        If Invoke(m_pIWebViewControlSettings, _
                  IWebViewControlSettings_PutIsIndexedDBEnabled, _
                  value) = S_OK Then
        End If
    End If
End Property

Public Property Get IsIndexedDBEnabled() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlSettings <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlSettings, _
                  IWebViewControlSettings_GetIsIndexedDBEnabled, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    IsIndexedDBEnabled = Ret
End Property

Public Property Let IsScriptNotifyAllowed(ByVal value As Boolean)
    If m_pIWebViewControlSettings <> 0& Then
        If Invoke(m_pIWebViewControlSettings, _
                  IWebViewControlSettings_PutIsScriptNotifyAllowed, _
                  value) = S_OK Then
        End If
    End If
End Property

Public Property Get IsScriptNotifyAllowed() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlSettings <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlSettings, _
                  IWebViewControlSettings_GetIsScriptNotifyAllowed, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    IsScriptNotifyAllowed = Ret
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function

