VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCUUSIEA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs As String = "{e3b81944-e4fc-43dc-94ca-f980f30bc51d}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs
    IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs_GetUri = 6
    IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs_GetHandled = 7
    IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs_PutHandled = 8
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs(ByVal pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs)
    m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs = pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs
End Property

Public Property Get IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs() As Long
    IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs = m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs
End Property

' IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs
Public Property Get Uri() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs, _
                  IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs_GetUri, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Uri = Ret
End Property

Public Property Get Handled() As Boolean
    Dim Ret As Boolean
    If m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs <> 0& Then
        Dim value As Boolean
        If Invoke(m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs, _
                  IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs_GetHandled, _
                  VarPtr(value)) = S_OK Then
            Ret = value
        End If
    End If
    Handled = Ret
End Property

Public Property Let Handled(ByVal value As Boolean)
    If m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs <> 0& Then
        If Invoke(m_pIWebViewControlUnsupportedUriSchemeIdentifiedEventArgs, _
                  IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs_PutHandled, _
                  value) = S_OK Then
        End If
    End If
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


