VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCUCIEA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlUnviewableContentIdentifiedEventArgs As String = "{4a9680db-88f2-4e20-b693-b4e2df4aa581}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlUnviewableContentIdentifiedEventArgs
    IWebViewControlUnviewableContentIdentifiedEventArgs_GetUri = 6
    IWebViewControlUnviewableContentIdentifiedEventArgs_GetReferrer = 7
    IWebViewControlUnviewableContentIdentifiedEventArgs_GetMediaType = 8
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlUnviewableContentIdentifiedEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlUnviewableContentIdentifiedEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlUnviewableContentIdentifiedEventArgs(ByVal pIWebViewControlUnviewableContentIdentifiedEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlUnviewableContentIdentifiedEventArgs)
    m_pIWebViewControlUnviewableContentIdentifiedEventArgs = pIWebViewControlUnviewableContentIdentifiedEventArgs
End Property

Public Property Get IWebViewControlUnviewableContentIdentifiedEventArgs() As Long
    IWebViewControlUnviewableContentIdentifiedEventArgs = m_pIWebViewControlUnviewableContentIdentifiedEventArgs
End Property

' IWebViewControlUnviewableContentIdentifiedEventArgs
Public Property Get Uri() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlUnviewableContentIdentifiedEventArgs <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlUnviewableContentIdentifiedEventArgs, _
                  IWebViewControlUnviewableContentIdentifiedEventArgs_GetUri, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Uri = Ret
End Property

Public Property Get Referrer() As clsURC
    Dim Ret As New clsURC
    If m_pIWebViewControlUnviewableContentIdentifiedEventArgs <> 0& Then
        Dim pIUriRuntimeClass As Long
        If Invoke(m_pIWebViewControlUnviewableContentIdentifiedEventArgs, _
                  IWebViewControlUnviewableContentIdentifiedEventArgs_GetReferrer, _
                  VarPtr(pIUriRuntimeClass)) = S_OK Then
            Ret.IUriRuntimeClass = pIUriRuntimeClass
        End If
    End If
    Set Referrer = Ret
End Property

Public Property Get MediaType() As String
    Dim Ret As String
    If m_pIWebViewControlUnviewableContentIdentifiedEventArgs <> 0& Then
        Dim hString As Long
        If Invoke(m_pIWebViewControlUnviewableContentIdentifiedEventArgs, _
                  IWebViewControlUnviewableContentIdentifiedEventArgs_GetMediaType, _
                  VarPtr(hString)) = S_OK Then
            Ret = GetWindowsString(hString)
        End If
    End If
    MediaType = Ret
End Property

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


