VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWVCWRREA"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const IID_IWebViewControlWebResourceRequestedEventArgs As String = "{44d6524d-55a4-4d8b-891c-931d8e25d42e}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWebViewControlWebResourceRequestedEventArgs
    IWebViewControlWebResourceRequestedEventArgs_GetDeferral = 6
    IWebViewControlWebResourceRequestedEventArgs_GetRequest = 7
    IWebViewControlWebResourceRequestedEventArgs_PutResponse = 8
    IWebViewControlWebResourceRequestedEventArgs_GetResponse = 9
 
End Enum

' ----==== Variablen ====----
Private m_pIWebViewControlWebResourceRequestedEventArgs As Long

' ----==== Class ====----
Private Sub Class_Initialize()
'
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWebViewControlWebResourceRequestedEventArgs)
End Sub

' ----==== Properties ====----
Public Property Let IWebViewControlWebResourceRequestedEventArgs(ByVal pIWebViewControlWebResourceRequestedEventArgs As Long)
    Call ReleaseIfc(m_pIWebViewControlWebResourceRequestedEventArgs)
    m_pIWebViewControlWebResourceRequestedEventArgs = pIWebViewControlWebResourceRequestedEventArgs
End Property

Public Property Get IWebViewControlWebResourceRequestedEventArgs() As Long
    IWebViewControlWebResourceRequestedEventArgs = m_pIWebViewControlWebResourceRequestedEventArgs
End Property

' IWebViewControlWebResourceRequestedEventArgs
Public Property Get Request() As clsHttpReqMsg
    Dim Ret As New clsHttpReqMsg
    If m_pIWebViewControlWebResourceRequestedEventArgs <> 0& Then
        Dim pIHttpRequestMessage As Long
        If Invoke(m_pIWebViewControlWebResourceRequestedEventArgs, _
                  IWebViewControlWebResourceRequestedEventArgs_GetRequest, _
                  VarPtr(pIHttpRequestMessage)) = S_OK Then
            Ret.IHttpRequestMessage = pIHttpRequestMessage
        End If
    End If
    Set Request = Ret
End Property

Public Property Let Response(ByVal HttpResponseMessage As clsHttpResMsg)
    If m_pIWebViewControlWebResourceRequestedEventArgs <> 0& And _
       HttpResponseMessage.IHttpResponseMessage <> 0& Then
        If Invoke(m_pIWebViewControlWebResourceRequestedEventArgs, _
                  IWebViewControlWebResourceRequestedEventArgs_GetResponse, _
                  HttpResponseMessage.IHttpResponseMessage) = S_OK Then
        End If
    End If
End Property

Public Property Get Response() As clsHttpResMsg
    Dim Ret As New clsHttpResMsg
    If m_pIWebViewControlWebResourceRequestedEventArgs <> 0& Then
        Dim pIHttpResponseMessage As Long
        If Invoke(m_pIWebViewControlWebResourceRequestedEventArgs, _
                  IWebViewControlWebResourceRequestedEventArgs_GetResponse, _
                  VarPtr(pIHttpResponseMessage)) = S_OK Then
            Ret.IHttpResponseMessage = pIHttpResponseMessage
        End If
    End If
    Set Response = Ret
End Property

' ----==== Functions ====----
' IWebViewControlWebResourceRequestedEventArgs
Public Function GetDeferral() As clsDeferral
    Dim Ret As New clsDeferral
    If m_pIWebViewControlWebResourceRequestedEventArgs <> 0& Then
        Dim pIDeferral As Long
        If Invoke(m_pIWebViewControlWebResourceRequestedEventArgs, _
                  IWebViewControlWebResourceRequestedEventArgs_GetDeferral, _
                  VarPtr(pIDeferral)) = S_OK Then
            Ret.IDeferral = pIDeferral
        End If
    End If
    Set GetDeferral = Ret
End Function

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


