VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsWFUDRC"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023

Option Explicit

' ----==== Const ====----
Private Const WindowsFoundationWwwFormUrlDecoder As String = "Windows.Foundation.WwwFormUrlDecoder"
Private Const IID_IWwwFormUrlDecoderRuntimeClass As String = "{d45a0451-f225-4542-9296-0e1df5d254df}"
Private Const IID_IWwwFormUrlDecoderRuntimeClassFactory As String = "{5b8c6b3d-24ae-41b5-a1bf-f0c3d544845b}"

' * Class implements the following interfaces:
' *    Windows.Foundation.Collections.IVectorView`1<Windows.Foundation.IWwwFormUrlDecoderEntry>
' *    Windows.Foundation.Collections.IIterable`1<Windows.Foundation.IWwwFormUrlDecoderEntry>
 
' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IWwwFormUrlDecoderRuntimeClassFactory
    IWwwFormUrlDecoderRuntimeClassFactory_CreateWwwFormUrlDecoder = 6
    
    ' IWwwFormUrlDecoderRuntimeClass
    IWwwFormUrlDecoderRuntimeClass_GetFirstValueByName = 6

End Enum

' ----==== Variablen ====----
Private m_pIWwwFormUrlDecoderRuntimeClass As Long
Private m_pIWwwFormUrlDecoderRuntimeClassFactory As Long

' ----==== Class ====----
Private Sub Class_Initialize()
    If GetActivationFactory(WindowsFoundationWwwFormUrlDecoder, _
                            IID_IWwwFormUrlDecoderRuntimeClassFactory, _
                            m_pIWwwFormUrlDecoderRuntimeClassFactory) Then
    End If
End Sub

Private Sub Class_Terminate()
    Call ReleaseIfc(m_pIWwwFormUrlDecoderRuntimeClass)
    Call ReleaseIfc(m_pIWwwFormUrlDecoderRuntimeClassFactory)
End Sub

' ----==== Properties ====----
Public Property Let IWwwFormUrlDecoderRuntimeClass(ByVal pIWwwFormUrlDecoderRuntimeClass As Long)
    Call ReleaseIfc(m_pIWwwFormUrlDecoderRuntimeClass)
    m_pIWwwFormUrlDecoderRuntimeClass = pIWwwFormUrlDecoderRuntimeClass
End Property

Public Property Get IWwwFormUrlDecoderRuntimeClass() As Long
    IWwwFormUrlDecoderRuntimeClass = m_pIWwwFormUrlDecoderRuntimeClass
End Property

' ----==== Functions ====----
' IWwwFormUrlDecoderRuntimeClassFactory
Public Function CreateWwwFormUrlDecoder(ByVal query As String) As Boolean
    Dim Ret As Boolean
    If m_pIWwwFormUrlDecoderRuntimeClassFactory <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(query)
        If hString <> 0& Then
            If Invoke(m_pIWwwFormUrlDecoderRuntimeClassFactory, _
                IWwwFormUrlDecoderRuntimeClassFactory_CreateWwwFormUrlDecoder, _
                hString, VarPtr(m_pIWwwFormUrlDecoderRuntimeClass)) = S_OK Then
                If m_pIWwwFormUrlDecoderRuntimeClass <> 0& Then Ret = True
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    CreateWwwFormUrlDecoder = Ret
End Function

' IWwwFormUrlDecoderRuntimeClass
Public Function GetFirstValueByName(ByVal name As String) As String
    Dim Ret As String
    If m_pIWwwFormUrlDecoderRuntimeClass <> 0& Then
        Dim hString As Long
        hString = CreateWindowsString(name)
        If hString <> 0& Then
            Dim value As Long
            If Invoke(m_pIWwwFormUrlDecoderRuntimeClass, _
                IWwwFormUrlDecoderRuntimeClass_GetFirstValueByName, _
                hString, VarPtr(value)) = S_OK Then
                Ret = GetWindowsString(value)
            End If
            Call DeleteWindowsString(hString)
        End If
    End If
    GetFirstValueByName = Ret
End Function

' ----==== Invoke ====----
Private Function Invoke(ByVal pInterface As Long, _
                        ByVal vtb As vtb_Interfaces, _
                        ParamArray var()) As Variant
    If pInterface <> 0& Then
        Invoke = OleInvoke(pInterface, vtb, var)
    End If
End Function


