VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "Form1"
   ClientHeight    =   8940
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   15765
   LinkTopic       =   "Form1"
   ScaleHeight     =   596
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   1051
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "Refresh"
      Height          =   405
      Left            =   2520
      TabIndex        =   3
      Top             =   60
      Width           =   1200
   End
   Begin VB.CommandButton cmdGoForward 
      Caption         =   "Go Forward"
      Height          =   405
      Left            =   1290
      TabIndex        =   2
      Top             =   60
      Width           =   1200
   End
   Begin VB.CommandButton cmdUserAgent 
      Caption         =   "Get UserAgent"
      Height          =   405
      Left            =   3780
      TabIndex        =   1
      Top             =   60
      Width           =   1200
   End
   Begin VB.CommandButton cmdGoBack 
      Caption         =   "Go Back"
      Height          =   405
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   1200
   End
   Begin VB.Label lblInfo 
      Height          =   225
      Left            =   30
      TabIndex        =   4
      Top             =   8670
      Width           =   5235
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 01/2023


Option Explicit

Private IsGetUserAgent As Boolean

Private WithEvents WebViewControl As clsWVC
Attribute WebViewControl.VB_VarHelpID = -1
Private WithEvents WebViewControlProcess As clsWVCP
Attribute WebViewControlProcess.VB_VarHelpID = -1

Private Sub WebViewControl_AcceleratorKeyPressed(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event AcceleratorKeyPressed"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim tCorePhysicalKeyStatus As CorePhysicalKeyStatus
            Dim WebViewControlAcceleratorKeyPressedEventArgs As New clsWVCAKPEA
            WebViewControlAcceleratorKeyPressedEventArgs.IWebViewControlAcceleratorKeyPressedEventArgs = args
            Debug.Print vbTab & "Handled: " & WebViewControlAcceleratorKeyPressedEventArgs.Handled
            Debug.Print vbTab & "EventType: " & WebViewControlAcceleratorKeyPressedEventArgs.EventType
            Debug.Print vbTab & "VirtualKey: " & WebViewControlAcceleratorKeyPressedEventArgs.VirtualKey
            Debug.Print vbTab & "RoutingStage: " & WebViewControlAcceleratorKeyPressedEventArgs.RoutingStage
            
            tCorePhysicalKeyStatus = WebViewControlAcceleratorKeyPressedEventArgs.KeyStatus
            Debug.Print vbTab & "CorePhysicalKeyStatus.RepeatCount: " & tCorePhysicalKeyStatus.RepeatCount
            Debug.Print vbTab & "CorePhysicalKeyStatus.ScanCode: " & tCorePhysicalKeyStatus.ScanCode
            Debug.Print vbTab & "CorePhysicalKeyStatus.IsExtendedKey: " & tCorePhysicalKeyStatus.IsExtendedKey
            Debug.Print vbTab & "CorePhysicalKeyStatus.IsMenuKeyDown: " & tCorePhysicalKeyStatus.IsMenuKeyDown
            Debug.Print vbTab & "CorePhysicalKeyStatus.WasKeyDown: " & tCorePhysicalKeyStatus.WasKeyDown
            Debug.Print vbTab & "CorePhysicalKeyStatus.IsKeyReleased: " & tCorePhysicalKeyStatus.IsKeyReleased
        End If
    End If
End Sub

Private Sub WebViewControl_ContainsFullScreenElementChanged(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "ContainsFullScreenElementChanged"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Call GetInspectableInfo(args, "ContainsFullScreenElementChanged -> IInspectable")
        End If
    End If
End Sub

Private Sub WebViewControl_ContentLoading(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event ContentLoading"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlContentLoadingEventArgs As New clsWVCCLEA
            WebViewControlContentLoadingEventArgs.IWebViewControlContentLoadingEventArgs = args
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlContentLoadingEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_DOMContentLoaded(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event DOMContentLoaded"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlDOMContentLoadedEventArgs As New clsWVCDCLEA
            WebViewControlDOMContentLoadedEventArgs.IWebViewControlDOMContentLoadedEventArgs = args
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlDOMContentLoadedEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_FrameContentLoading(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event FrameContentLoading"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlContentLoadingEventArgs As New clsWVCCLEA
            WebViewControlContentLoadingEventArgs.IWebViewControlContentLoadingEventArgs = args
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlContentLoadingEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_FrameDOMContentLoaded(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event FrameDOMContentLoaded"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlDOMContentLoadedEventArgs As New clsWVCDCLEA
            WebViewControlDOMContentLoadedEventArgs.IWebViewControlDOMContentLoadedEventArgs = args
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlDOMContentLoadedEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_FrameNavigationCompleted(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event FrameNavigationCompleted"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlNavigationCompletedEventArgs As New clsWVCNCEA
            WebViewControlNavigationCompletedEventArgs.IWebViewControlNavigationCompletedEventArgs = args
            Debug.Print vbTab & "IsSuccess: " & WebViewControlNavigationCompletedEventArgs.IsSuccess
            Debug.Print vbTab & "WebErrorStatus: " & WebViewControlNavigationCompletedEventArgs.WebErrorStatus
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlNavigationCompletedEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_FrameNavigationStarting(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event FrameNavigationStarting"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlNavigationStartingEventArgs As New clsWVCNSEA
            WebViewControlNavigationStartingEventArgs.IWebViewControlNavigationStartingEventArgs = args
            Debug.Print vbTab & "Cancel: " & WebViewControlNavigationStartingEventArgs.Cancel
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlNavigationStartingEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_GotFocus(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event GotFocus"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Call GetInspectableInfo(args, "GotFocus -> IInspectable")
        End If
    End If
End Sub

Private Sub WebViewControl_LongRunningScriptDetected(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event LongRunningScriptDetected"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlLongRunningScriptDetectedEventArgs As New clsWVCLRSDEA
            WebViewControlLongRunningScriptDetectedEventArgs.IWebViewControlLongRunningScriptDetectedEventArgs = args
            Debug.Print vbTab & "ExecutionTime: " & WebViewControlLongRunningScriptDetectedEventArgs.ExecutionTime
            Debug.Print vbTab & "StopPageScriptExecution: " & WebViewControlLongRunningScriptDetectedEventArgs.StopPageScriptExecution
        End If
    End If
End Sub

Private Sub WebViewControl_LostFocus(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event LostFocus"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Call GetInspectableInfo(args, "LostFocus -> IInspectable")
        End If
    End If
End Sub

Private Sub WebViewControl_MoveFocusRequested(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event MoveFocusRequested"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlMoveFocusRequestedEventArgs As New clsWVCMFREA
            WebViewControlMoveFocusRequestedEventArgs.IWebViewControlMoveFocusRequestedEventArgs = args
            Debug.Print vbTab & "Reason: " & WebViewControlMoveFocusRequestedEventArgs.Reason
        End If
    End If
End Sub

Private Sub WebViewControl_NavigationCompleted(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event NavigationCompleted"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlNavigationCompletedEventArgs As New clsWVCNCEA
            WebViewControlNavigationCompletedEventArgs.IWebViewControlNavigationCompletedEventArgs = args
            Debug.Print vbTab & "IsSuccess: " & WebViewControlNavigationCompletedEventArgs.IsSuccess
            Debug.Print vbTab & "WebErrorStatus: " & WebViewControlNavigationCompletedEventArgs.WebErrorStatus
            lblInfo.Caption = "AbsoluteUri: " & WebViewControlNavigationCompletedEventArgs.Uri.AbsoluteUri
            Debug.Print vbTab & "AbsoluteUri: " & lblInfo.Caption
        End If
    End If
    Me.Caption = "WinRT-WebView: " & WebViewControl.DocumentTitle
    cmdGoBack.Enabled = WebViewControl.CanGoBack
    cmdGoForward.Enabled = WebViewControl.CanGoForward
    
    If IsGetUserAgent Then
        Call MsgBox(WebViewControl.InvokeScriptAsync("GetUserAgent", 0&), vbOKOnly, "UserAgent")  '<- arguments -> IIterable_1_HSTRING
        IsGetUserAgent = False
    End If

End Sub

Private Sub WebViewControl_NavigationStarting(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event NavigationStarting"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlNavigationStartingEventArgs As New clsWVCNSEA
            WebViewControlNavigationStartingEventArgs.IWebViewControlNavigationStartingEventArgs = args
            Debug.Print vbTab & "Cancel: " & WebViewControlNavigationStartingEventArgs.Cancel
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlNavigationStartingEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_NewWindowRequested(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event NewWindowRequested"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlNewWindowRequestedEventArgs As New clsWVCNWREA
            WebViewControlNewWindowRequestedEventArgs.IWebViewControlNewWindowRequestedEventArgs = args
            Debug.Print vbTab & "Handled: " & WebViewControlNewWindowRequestedEventArgs.Handled
            Debug.Print vbTab & "Uri.AbsoluteUri: " & WebViewControlNewWindowRequestedEventArgs.Uri.AbsoluteUri
            Debug.Print vbTab & "Referrer.AbsoluteUri: " & WebViewControlNewWindowRequestedEventArgs.Referrer.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_PermissionRequested(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event PermissionRequested"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlPermissionRequestedEventArgs As New clsWVCPREA
            WebViewControlPermissionRequestedEventArgs.IWebViewControlPermissionRequestedEventArgs = args
            Debug.Print vbTab & "Id: " & WebViewControlPermissionRequestedEventArgs.PermissionRequest.Id
            Debug.Print vbTab & "PermissionType: " & WebViewControlPermissionRequestedEventArgs.PermissionRequest.PermissionType
            Debug.Print vbTab & "State: " & WebViewControlPermissionRequestedEventArgs.PermissionRequest.State
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlPermissionRequestedEventArgs.PermissionRequest.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_ScriptNotify(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event ScriptNotify"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlScriptNotifyEventArgs As New clsWVCSNEA
            WebViewControlScriptNotifyEventArgs.IWebViewControlScriptNotifyEventArgs = args
            Debug.Print vbTab & "Value: " & WebViewControlScriptNotifyEventArgs.value
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlScriptNotifyEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_UnsafeContentWarningDisplaying(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event UnsafeContentWarningDisplaying"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Call GetInspectableInfo(args, "UnsafeContentWarningDisplaying -> IInspectable")
        End If
    End If
End Sub

Private Sub WebViewControl_UnsupportedUriSchemeIdentified(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event UnsupportedUriSchemeIdentified"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlUnsupportedUriSchemeIdentifiedEventArgs As New clsWVCUUSIEA
            WebViewControlUnsupportedUriSchemeIdentifiedEventArgs.IWebViewControlUnsupportedUriSchemeIdentifiedEventArgs = args
            Debug.Print vbTab & "Handled: " & WebViewControlUnsupportedUriSchemeIdentifiedEventArgs.Handled
            Debug.Print vbTab & "AbsoluteUri: " & WebViewControlUnsupportedUriSchemeIdentifiedEventArgs.Uri.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_UnviewableContentIdentified(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event UnviewableContentIdentified"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlUnviewableContentIdentifiedEventArgs As New clsWVCUCIEA
            WebViewControlUnviewableContentIdentifiedEventArgs.IWebViewControlUnviewableContentIdentifiedEventArgs = args
            Debug.Print vbTab & "MediaType: " & WebViewControlUnviewableContentIdentifiedEventArgs.MediaType
            Debug.Print vbTab & "Uri.AbsoluteUri: " & WebViewControlUnviewableContentIdentifiedEventArgs.Uri.AbsoluteUri
            Debug.Print vbTab & "Referrer.AbsoluteUri: " & WebViewControlUnviewableContentIdentifiedEventArgs.Referrer.AbsoluteUri
        End If
    End If
End Sub

Private Sub WebViewControl_WebResourceRequested(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event WebResourceRequested"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Dim WebViewControlWebResourceRequestedEventArgs As New clsWVCWRREA
            WebViewControlWebResourceRequestedEventArgs.IWebViewControlWebResourceRequestedEventArgs = args
            
            Dim HttpRequestMessage As clsHttpReqMsg
            Set HttpRequestMessage = WebViewControlWebResourceRequestedEventArgs.Request
            If Not HttpRequestMessage Is Nothing Then
                Debug.Print vbTab & "RequestMessage.ToString: " & HttpRequestMessage.ToString
                Debug.Print vbTab & "RequestMessage.PrivacyAnnotation: " & HttpRequestMessage.PrivacyAnnotation
                Debug.Print vbTab & "RequestMessage.RequestUri.AbsoluteUri: " & HttpRequestMessage.RequestUri.AbsoluteUri
                Debug.Print vbTab & "RequestMessage.Method.ToString: " & HttpRequestMessage.Method.ToString
                Debug.Print vbTab & "RequestMessage.TransportInformation.ToString: " & HttpRequestMessage.TransportInformation.ToString
                Debug.Print vbTab & "RequestMessage.Headers.ToString: " & HttpRequestMessage.Headers.ToString
                
                
                
                Dim propCount As Long
                propCount = HttpRequestMessage.PropertiesCount
                Debug.Print vbTab & "RequestMessage.PropertiesCount: " & propCount
                If propCount > 0 Then
                    Dim propItem As Long
                    Dim tKeyValuePair() As KeyValuePair
                    tKeyValuePair = HttpRequestMessage.Properties
                    For propItem = 0 To propCount - 1
                        Debug.Print vbTab & "KeyValuePair.Key: " & tKeyValuePair(propItem).Key
                        Debug.Print vbTab & "tKeyValuePair.Value"
                        Call GetInspectableInfo(tKeyValuePair(propItem).value, "tKeyValuePair.Value")
                    Next
                End If
            End If
            
            Dim HttpResponseMessage As clsHttpResMsg
            Set HttpResponseMessage = WebViewControlWebResourceRequestedEventArgs.Response
            If Not HttpResponseMessage Is Nothing Then
                Debug.Print vbTab & "Response.ToString: " & HttpResponseMessage.ToString
            End If
            
        End If
    End If
End Sub

Private Sub WebViewControlProcess_ProcessExited(ByVal sender As Long, ByVal args As Long)
    Debug.Print String$(60, "*")
    Debug.Print "Event ProcessExited"
    If WebViewControl.IWebViewControl = sender Then
        If args <> 0& Then
            Call GetInspectableInfo(args, "ProcessExited -> IInspectable")
        End If
    End If
End Sub

Private Sub Form_Load()
    Me.ScaleMode = vbPixels
    cmdGoBack.Enabled = False
    cmdGoForward.Enabled = False
    Me.Caption = "WinRT-WebView:"
    Call lblInfo.Move(0, Me.ScaleHeight - 15, Me.ScaleWidth, 15)
    
    Set WebViewControlProcess = New clsWVCP
    
    If WebViewControlProcess.Create Then
        Set WebViewControl = WebViewControlProcess.CreateWebViewControlAsync(Me.hWnd, NewRect(0, 35, Me.ScaleWidth, Me.ScaleHeight - 50))
        
        ' WebViewControl.Scaling = 0.8 '1 = 100%
        
        Dim UriRuntimeClass As New clsURC
        If UriRuntimeClass.CreateUri("https://www.google.de/") Then
            Call WebViewControl.Navigate(UriRuntimeClass)
        End If
    
    End If
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    WebViewControl.Closing
    WebViewControlProcess.Terminate
    Set WebViewControl = Nothing
    Set WebViewControlProcess = Nothing
End Sub

Private Sub Form_Resize()
    If Me.WindowState <> vbMinimized Then
        Call lblInfo.Move(0, Me.ScaleHeight - 15, Me.ScaleWidth, 15)
        WebViewControl.bounds = NewRect(0, 35, Me.ScaleWidth, Me.ScaleHeight - 50)
    End If
End Sub

Private Sub cmdGoBack_Click()
    If WebViewControl.CanGoBack Then WebViewControl.GoBack
End Sub

Private Sub cmdGoForward_Click()
    If WebViewControl.CanGoForward Then WebViewControl.GoForward
End Sub

Private Sub cmdRefresh_Click()
    WebViewControl.Refresh
End Sub

Private Sub cmdUserAgent_Click()
    IsGetUserAgent = True
    Call WebViewControl.NavigateToString("<html><head><script>function GetUserAgent(){return navigator.userAgent;}</script></head></html>")
End Sub


