Attribute VB_Name = "modITEH_WebResourceRequested"
' Autor: F. Schler (frank@activevb.de)
' Datum: 12/2022

Option Explicit

' ----==== Const ====----
Private Const ITypedEventHandler_WebViewControlWebResourceRequestedEventArgs As String = "{3a6ed2bc-032b-5ec7-a20a-c1ef49250c3c}"

' ----==== Types ====----
Private Type tInterface
    pVTable As Long
End Type

Private Type tInterface_VTable
    VTable(0 To 3) As Long
End Type

' ----==== Variablen ====----
Private m_RefCount As Long
Private m_Class As clsWVC
Private m_Interface As tInterface
Private m_Interface_VTable As tInterface_VTable

Public Function Create(ByVal WebViewControl As clsWVC) As Long
    Set m_Class = WebViewControl
    With m_Interface_VTable
        .VTable(0) = ProcPtr(AddressOf QueryInterface)
        .VTable(1) = ProcPtr(AddressOf AddRef)
        .VTable(2) = ProcPtr(AddressOf Release)
        .VTable(3) = ProcPtr(AddressOf Invoke)
    End With
    With m_Interface
        .pVTable = VarPtr(m_Interface_VTable)
    End With
    Create = VarPtr(m_Interface)
End Function

Private Function QueryInterface(ByVal this As Long, _
                                ByRef riid As GUID, _
                                ByRef pvObj As Long) As Long
    Dim lngRet As Long
    Select Case UCase$(Guid2Str(riid))
    Case UCase$(IID_IUnknown), UCase$(ITypedEventHandler_WebViewControlWebResourceRequestedEventArgs)
        Call AddRef(this)
        pvObj = VarPtr(m_Interface)
        lngRet = S_OK
    Case Else
        pvObj = 0&
        lngRet = E_NOINTERFACE
    End Select
    QueryInterface = lngRet
End Function

Private Function AddRef(ByVal this As Long) As Long
    m_RefCount = m_RefCount + 1
    AddRef = m_RefCount
End Function

Private Function Release(ByVal this As Long) As Long
    m_RefCount = m_RefCount - 1
    Release = m_RefCount
End Function

Private Function Invoke(ByVal this As Long, _
                        ByVal sender As Long, _
                        ByVal args As Long) As Long
    Call m_Class.Invoke_WebResourceRequested(sender, args)
End Function

