Attribute VB_Name = "modWin32"
Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Private Const CC_STDCALL As Long = &H4&
Public Const E_NOINTERFACE As Long = &H80004002

Public Const IID_IUnknown As String = "{00000000-0000-0000-c000-000000000046}"
Public Const IID_IStringable As String = "{96369f54-8eb6-48f0-abce-c1b211e627c3}"
Private Const IID_IClosable As String = "{30d5a829-7fa4-4026-83bb-d75bae4ea99e}"
Private Const IID_IAsyncInfo As String = "{00000036-0000-0000-c000-000000000046}"

' ----==== Enums ====----
Private Enum vtb_Interfaces
    
    ' IUnknown
    IUnknown_QueryInterface = 0
    IUnknown_Release = 2

    ' IInspectable
    IInspectable_GetIids = 3
    IInspectable_GetRuntimeClassName = 4
    IInspectable_GetTrustLevel = 5
    
    ' IAsyncInfo
    IAsyncInfo_GetStatus = 7
    IAsyncInfo_Close = 10

    ' IAsyncOperation
    IAsyncOperation_GetResults = 8
    
    ' IClosable
    IClosable_Close = 6

End Enum

Private Enum AsyncStatus
    Started = 0
    Completed = 1
    Canceled = 2
    Error = 3
End Enum

Private Enum TrustLevel
    BaseTrust = 0
    PartialTrust = 1
    FullTrust = 2
End Enum

Public Enum WebViewControlMoveFocusReason
    WebViewControlMoveFocusReason_Programmatic = 0
    WebViewControlMoveFocusReason_Next = 1
    WebViewControlMoveFocusReason_Previous = 2
End Enum

Public Enum WebViewControlPermissionType
    WebViewControlPermissionType_Geolocation = 0
    WebViewControlPermissionType_UnlimitedIndexedDBQuota = 1
    WebViewControlPermissionType_Media = 2
    WebViewControlPermissionType_PointerLock = 3
    WebViewControlPermissionType_WebNotifications = 4
    WebViewControlPermissionType_Screen = 5
    WebViewControlPermissionType_ImmersiveView = 6
End Enum
                
Public Enum WebViewControlPermissionState
    WebViewControlPermissionState_Unknown = 0
    WebViewControlPermissionState_Defer = 1
    WebViewControlPermissionState_Allow = 2
    WebViewControlPermissionState_Deny = 3
End Enum

Public Enum WebViewControlProcessCapabilityState
    WebViewControlProcessCapabilityState_Default = 0
    WebViewControlProcessCapabilityState_Disabled = 1
    WebViewControlProcessCapabilityState_Enabled = 2
End Enum
                                    
Public Enum WebErrorStatus
    WebErrorStatus_Unknown = 0
    WebErrorStatus_CertificateCommonNameIsIncorrect = 1
    WebErrorStatus_CertificateExpired = 2
    WebErrorStatus_CertificateContainsErrors = 3
    WebErrorStatus_CertificateRevoked = 4
    WebErrorStatus_CertificateIsInvalid = 5
    WebErrorStatus_ServerUnreachable = 6
    WebErrorStatus_Timeout = 7
    WebErrorStatus_ErrorHttpInvalidServerResponse = 8
    WebErrorStatus_ConnectionAborted = 9
    WebErrorStatus_ConnectionReset = 10
    WebErrorStatus_Disconnected = 11
    WebErrorStatus_HttpToHttpsOnRedirection = 12
    WebErrorStatus_HttpsToHttpOnRedirection = 13
    WebErrorStatus_CannotConnect = 14
    WebErrorStatus_HostNameNotResolved = 15
    WebErrorStatus_OperationCanceled = 16
    WebErrorStatus_RedirectFailed = 17
    WebErrorStatus_UnexpectedStatusCode = 18
    WebErrorStatus_UnexpectedRedirection = 19
    WebErrorStatus_UnexpectedClientError = 20
    WebErrorStatus_UnexpectedServerError = 21
    WebErrorStatus_InsufficientRangeSupport = 22
    WebErrorStatus_MissingContentLengthSupport = 23
    WebErrorStatus_MultipleChoices = 300
    WebErrorStatus_MovedPermanently = 301
    WebErrorStatus_Found = 302
    WebErrorStatus_SeeOther = 303
    WebErrorStatus_NotModified = 304
    WebErrorStatus_UseProxy = 305
    WebErrorStatus_TemporaryRedirect = 307
    WebErrorStatus_BadRequest = 400
    WebErrorStatus_Unauthorized = 401
    WebErrorStatus_PaymentRequired = 402
    WebErrorStatus_Forbidden = 403
    WebErrorStatus_NotFound = 404
    WebErrorStatus_MethodNotAllowed = 405
    WebErrorStatus_NotAcceptable = 406
    WebErrorStatus_ProxyAuthenticationRequired = 407
    WebErrorStatus_RequestTimeout = 408
    WebErrorStatus_Conflict = 409
    WebErrorStatus_Gone = 410
    WebErrorStatus_LengthRequired = 411
    WebErrorStatus_PreconditionFailed = 412
    WebErrorStatus_RequestEntityTooLarge = 413
    WebErrorStatus_RequestUriTooLong = 414
    WebErrorStatus_UnsupportedMediaType = 415
    WebErrorStatus_RequestedRangeNotSatisfiable = 416
    WebErrorStatus_ExpectationFailed = 417
    WebErrorStatus_InternalServerError = 500
    WebErrorStatus_NotImplemented = 501
    WebErrorStatus_BadGateway = 502
    WebErrorStatus_ServiceUnavailable = 503
    WebErrorStatus_GatewayTimeout = 504
    WebErrorStatus_HttpVersionNotSupported = 505
End Enum

Public Enum CoreAcceleratorKeyEventType
    CoreAcceleratorKeyEventType_KeyDown = 0
    CoreAcceleratorKeyEventType_KeyUp = 1
    CoreAcceleratorKeyEventType_Character = 2
    CoreAcceleratorKeyEventType_DeadCharacter = 3
    CoreAcceleratorKeyEventType_SystemKeyDown = 4
    CoreAcceleratorKeyEventType_SystemKeyUp = 5
    CoreAcceleratorKeyEventType_SystemCharacter = 6
    CoreAcceleratorKeyEventType_SystemDeadCharacter = 7
    CoreAcceleratorKeyEventType_UnicodeCharacter = 8
End Enum

Public Enum WebViewControlAcceleratorKeyRoutingStage
    WebViewControlAcceleratorKeyRoutingStage_Tunneling = 0
    WebViewControlAcceleratorKeyRoutingStage_Bubbling = 1
End Enum

Public Enum VirtualKey
    VirtualKey_None = 0
    VirtualKey_LeftButton = 1
    VirtualKey_RightButton = 2
    VirtualKey_Cancel = 3
    VirtualKey_MiddleButton = 4
    VirtualKey_XButton1 = 5
    VirtualKey_XButton2 = 6
    VirtualKey_Back = 8
    VirtualKey_Tab = 9
    VirtualKey_Clear = 12
    VirtualKey_Enter = 13
    VirtualKey_Shift = 16
    VirtualKey_Control = 17
    VirtualKey_Menu = 18
    VirtualKey_Pause = 19
    VirtualKey_CapitalLock = 20
    VirtualKey_Kana = 21
    VirtualKey_Hangul = 21
    VirtualKey_ImeOn = 22
    VirtualKey_Junja = 23
    VirtualKey_Final = 24
    VirtualKey_Hanja = 25
    VirtualKey_Kanji = 25
    VirtualKey_ImeOff = 26
    VirtualKey_Escape = 27
    VirtualKey_Convert = 28
    VirtualKey_NonConvert = 29
    VirtualKey_Accept = 30
    VirtualKey_ModeChange = 31
    VirtualKey_Space = 32
    VirtualKey_PageUp = 33
    VirtualKey_PageDown = 34
    VirtualKey_End = 35
    VirtualKey_Home = 36
    VirtualKey_Left = 37
    VirtualKey_Up = 38
    VirtualKey_Right = 39
    VirtualKey_Down = 40
    VirtualKey_Select = 41
    VirtualKey_Print = 42
    VirtualKey_Execute = 43
    VirtualKey_Snapshot = 44
    VirtualKey_Insert = 45
    VirtualKey_Delete = 46
    VirtualKey_Help = 47
    VirtualKey_Number0 = 48
    VirtualKey_Number1 = 49
    VirtualKey_Number2 = 50
    VirtualKey_Number3 = 51
    VirtualKey_Number4 = 52
    VirtualKey_Number5 = 53
    VirtualKey_Number6 = 54
    VirtualKey_Number7 = 55
    VirtualKey_Number8 = 56
    VirtualKey_Number9 = 57
    VirtualKey_A = 65
    VirtualKey_B = 66
    VirtualKey_C = 67
    VirtualKey_D = 68
    VirtualKey_E = 69
    VirtualKey_F = 70
    VirtualKey_G = 71
    VirtualKey_H = 72
    VirtualKey_I = 73
    VirtualKey_J = 74
    VirtualKey_K = 75
    VirtualKey_L = 76
    VirtualKey_M = 77
    VirtualKey_N = 78
    VirtualKey_O = 79
    VirtualKey_P = 80
    VirtualKey_Q = 81
    VirtualKey_R = 82
    VirtualKey_S = 83
    VirtualKey_T = 84
    VirtualKey_U = 85
    VirtualKey_V = 86
    VirtualKey_W = 87
    VirtualKey_X = 88
    VirtualKey_Y = 89
    VirtualKey_Z = 90
    VirtualKey_LeftWindows = 91
    VirtualKey_RightWindows = 92
    VirtualKey_Application = 93
    VirtualKey_Sleep = 95
    VirtualKey_NumberPad0 = 96
    VirtualKey_NumberPad1 = 97
    VirtualKey_NumberPad2 = 98
    VirtualKey_NumberPad3 = 99
    VirtualKey_NumberPad4 = 100
    VirtualKey_NumberPad5 = 101
    VirtualKey_NumberPad6 = 102
    VirtualKey_NumberPad7 = 103
    VirtualKey_NumberPad8 = 104
    VirtualKey_NumberPad9 = 105
    VirtualKey_Multiply = 106
    VirtualKey_Add = 107
    VirtualKey_Separator = 108
    VirtualKey_Subtract = 109
    VirtualKey_Decimal = 110
    VirtualKey_Divide = 111
    VirtualKey_F1 = 112
    VirtualKey_F2 = 113
    VirtualKey_F3 = 114
    VirtualKey_F4 = 115
    VirtualKey_F5 = 116
    VirtualKey_F6 = 117
    VirtualKey_F7 = 118
    VirtualKey_F8 = 119
    VirtualKey_F9 = 120
    VirtualKey_F10 = 121
    VirtualKey_F11 = 122
    VirtualKey_F12 = 123
    VirtualKey_F13 = 124
    VirtualKey_F14 = 125
    VirtualKey_F15 = 126
    VirtualKey_F16 = 127
    VirtualKey_F17 = 128
    VirtualKey_F18 = 129
    VirtualKey_F19 = 130
    VirtualKey_F20 = 131
    VirtualKey_F21 = 132
    VirtualKey_F22 = 133
    VirtualKey_F23 = 134
    VirtualKey_F24 = 135
    VirtualKey_NavigationView = 136
    VirtualKey_NavigationMenu = 137
    VirtualKey_NavigationUp = 138
    VirtualKey_NavigationDown = 139
    VirtualKey_NavigationLeft = 140
    VirtualKey_NavigationRight = 141
    VirtualKey_NavigationAccept = 142
    VirtualKey_NavigationCancel = 143
    VirtualKey_NumberKeyLock = 144
    VirtualKey_Scroll = 145
    VirtualKey_LeftShift = 160
    VirtualKey_RightShift = 161
    VirtualKey_LeftControl = 162
    VirtualKey_RightControl = 163
    VirtualKey_LeftMenu = 164
    VirtualKey_RightMenu = 165
    VirtualKey_GoBack = 166
    VirtualKey_GoForward = 167
    VirtualKey_Refresh = 168
    VirtualKey_Stop = 169
    VirtualKey_Search = 170
    VirtualKey_Favorites = 171
    VirtualKey_GoHome = 172
    VirtualKey_GamepadA = 195
    VirtualKey_GamepadB = 196
    VirtualKey_GamepadX = 197
    VirtualKey_GamepadY = 198
    VirtualKey_GamepadRightShoulder = 199
    VirtualKey_GamepadLeftShoulder = 200
    VirtualKey_GamepadLeftTrigger = 201
    VirtualKey_GamepadRightTrigger = 202
    VirtualKey_GamepadDPadUp = 203
    VirtualKey_GamepadDPadDown = 204
    VirtualKey_GamepadDPadLeft = 205
    VirtualKey_GamepadDPadRight = 206
    VirtualKey_GamepadMenu = 207
    VirtualKey_GamepadView = 208
    VirtualKey_GamepadLeftThumbstickButton = 209
    VirtualKey_GamepadRightThumbstickButton = 210
    VirtualKey_GamepadLeftThumbstickUp = 211
    VirtualKey_GamepadLeftThumbstickDown = 212
    VirtualKey_GamepadLeftThumbstickRight = 213
    VirtualKey_GamepadLeftThumbstickLeft = 214
    VirtualKey_GamepadRightThumbstickUp = 215
    VirtualKey_GamepadRightThumbstickDown = 216
    VirtualKey_GamepadRightThumbstickRight = 217
    VirtualKey_GamepadRightThumbstickLeft = 218
End Enum

' ----==== Types ====----
Public Type GUID
    data1 As Long
    data2 As Long
    data3 As Long
    data4 As Long
End Type

Public Type KeyValuePair ' HSTRING_IInspectable
    Key As String 'hString
    value As Long 'IInspectable
End Type

Public Type Rect
    X As Single
    Y As Single
    Width As Single
    Height As Single
End Type
            
Public Type Color
    A As Byte
    R As Byte
    G As Byte
    B As Byte
End Type

' so richtig???
Public Type CorePhysicalKeyStatus
    RepeatCount As Long
    ScanCode As Long
    IsExtendedKey As Boolean
    IsMenuKeyDown As Boolean
    WasKeyDown As Boolean
    IsKeyReleased As Boolean
End Type
                
' ----==== Ole32.dll Declarations ====----
Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pCLSID As GUID) As Long
                         
Private Declare Function StringFromGUID Lib "Ole32.dll" _
                         Alias "StringFromGUID2" ( _
                         ByRef rguid As GUID, _
                         ByVal lpsz As Long, _
                         ByVal cchMax As Long) As Long
                         
Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)
                         
' ----==== Oleaut32.dll Declarations ====----
Private Declare Function DispCallFunc Lib "Oleaut32.dll" ( _
                         ByVal pvInstance As Long, _
                         ByVal oVft As Long, _
                         ByVal cc As Long, _
                         ByVal vtReturn As VbVarType, _
                         ByVal cActuals As Long, _
                         ByVal prgvt As Any, _
                         ByVal prgpvarg As Any, _
                         ByRef pvargResult As Variant) As Long

' ----==== Kernel32.dll Declarations ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long

' ----==== Combase.dll Declarations ====----
Private Declare Function WindowsCreateString Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByVal lenght As Long, _
                         ByRef hString As Long) As Long

Private Declare Function WindowsDeleteString Lib "Combase.dll" ( _
                         ByVal sourceString As Long) As Long

Private Declare Function WindowsGetStringRawBuffer Lib "Combase.dll" ( _
                         ByVal sourceString As Long, _
                         ByRef length As Long) As Long

Private Declare Function RoGetActivationFactory Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef riid As GUID, _
                         ByRef factory As Long) As Long

Private Declare Function RoActivateInstance Lib "Combase.dll" ( _
                         ByVal activatableClassId As Long, _
                         ByRef instance As Long) As Long

' ----==== WinRT Functions ====----
Public Function GetActivationFactory(ByVal ClassName As String, _
                                     ByVal iid As String, _
                                     ByRef pFactory As Long) As Boolean
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            If RoGetActivationFactory(hString, Str2Guid(iid), pFactory) = S_OK Then
                GetActivationFactory = True
            End If
            Call WindowsDeleteString(hString)
        End If
    End If
End Function

Public Function GetActivateInstance(ByVal ClassName As String, _
                                    ByVal iid As String, _
                                    ByRef pInstance As Long) As Boolean
    Dim hString As Long
    If WindowsCreateString(StrPtr(ClassName), Len(ClassName), hString) = S_OK Then
        If hString <> 0& Then
            Dim pIInspectable As Long
            If RoActivateInstance(hString, pIInspectable) = S_OK Then
                If pIInspectable <> 0& Then
                    If QueryIfc(pIInspectable, iid, pInstance) Then
                        If pInstance <> 0& Then GetActivateInstance = True
                    End If
                    Call ReleaseIfc(pIInspectable)
                End If
            End If
            Call WindowsDeleteString(hString)
        End If
    End If
End Function

Public Function CreateWindowsString(ByVal value As String) As Long
    If value <> vbNullString Then
        Call WindowsCreateString(StrPtr(value), Len(value), CreateWindowsString)
    End If
End Function

Public Function GetWindowsString(ByVal hString As Long) As String
    If hString <> 0& Then
        GetWindowsString = Ptr2Str(WindowsGetStringRawBuffer(hString, 0&))
        Call DeleteWindowsString(hString)
    End If
End Function

Public Function DeleteWindowsString(ByRef hString As Long) As Boolean
    If hString <> 0& Then
        If WindowsDeleteString(hString) = S_OK Then
            hString = 0&
            DeleteWindowsString = True
        End If
    End If
End Function

Public Function Await(ByRef pInterface As Long) As Boolean
    If pInterface <> 0& Then
        Dim pIAsyncInfo As Long
        If QueryIfc(pInterface, IID_IAsyncInfo, pIAsyncInfo) Then
            Dim eStatus As AsyncStatus
            Do
                If InvokeIfc(pIAsyncInfo, IAsyncInfo_GetStatus, VarPtr(eStatus)) = S_OK Then
                    DoEvents
                End If
            Loop While eStatus = Started
            If eStatus = Completed Then
                Dim pRet As Long
                If InvokeIfc(pInterface, IAsyncOperation_GetResults, VarPtr(pRet)) = S_OK Then
                    If pRet <> 0& Then
                        Call ReleaseIfc(pInterface)
                        pInterface = pRet
                        Await = True
                    Else
                        Call ReleaseIfc(pInterface)
                    End If
                Else
                    Call ReleaseIfc(pInterface)
                End If
            Else
                Call ReleaseIfc(pInterface)
            End If
            Call InvokeIfc(pIAsyncInfo, IAsyncInfo_Close)
            Call ReleaseIfc(pIAsyncInfo)
        End If
    End If
End Function

Public Sub GetInspectableInfo(ByVal pInspectableInterface As Long, _
                              Optional ByVal interfaceName As String = vbNullString)
    If pInspectableInterface <> 0& Then
        If interfaceName <> vbNullString Then
            Debug.Print "Inspectable Info for: " & interfaceName
        End If
        Debug.Print "RuntimeClassName = " & GetRuntimeClassName(pInspectableInterface)
        Dim eTrustLevel As TrustLevel
        eTrustLevel = GetTrustLevel(pInspectableInterface)
        Select Case eTrustLevel
            Case TrustLevel.BaseTrust
                Debug.Print "TrustLevel = BaseTrust"
            Case TrustLevel.FullTrust
                Debug.Print "TrustLevel = FullTrust"
            Case TrustLevel.PartialTrust
                Debug.Print "TrustLevel = PartialTrust"
            Case Else
                Debug.Print "TrustLevel = UnknownTrust"
        End Select
        Dim tIIDs() As GUID
        Dim lngIIDsCount As Long
        lngIIDsCount = GetIIDs(pInspectableInterface, tIIDs)
        Debug.Print "AviableIIDsCount = " & CStr(lngIIDsCount)
        If lngIIDsCount > 0 Then
            Dim lngIIDsItem As Long
            For lngIIDsItem = 0 To lngIIDsCount - 1
                Debug.Print "    AviableIID " & CStr(lngIIDsItem + 1) & _
                            " = " & Guid2Str(tIIDs(lngIIDsItem))
            Next
        End If
        Debug.Print String(60, "-")
    End If
End Sub

Private Function GetIIDs(ByVal pInterface As Long, _
                         ByRef iids() As GUID) As Long
    If pInterface <> 0& Then
        Dim count As Long
        Dim pIIDs As Long
        If InvokeIfc(pInterface, IInspectable_GetIids, VarPtr(count), VarPtr(pIIDs)) = S_OK Then
            If count > 0& Then
                Dim bytes As Long
                Dim item As Long
                ReDim iids(count - 1)
                For item = 0 To count - 1
                    bytes = Len(iids(item))
                    Call CopyMemory(iids(item), ByVal pIIDs + (bytes * item), bytes)
                Next
                GetIIDs = count
            End If
        End If
    End If
End Function

Private Function GetRuntimeClassName(ByVal pInterface As Long) As String
    If pInterface <> 0& Then
        Dim hString As Long
        If InvokeIfc(pInterface, IInspectable_GetRuntimeClassName, VarPtr(hString)) = S_OK Then
            If hString <> 0& Then
                GetRuntimeClassName = GetWindowsString(hString)
            End If
        End If
    End If
End Function

Private Function GetTrustLevel(ByVal pInterface As Long) As TrustLevel
    If pInterface <> 0& Then
        Dim value As Long
        If InvokeIfc(pInterface, IInspectable_GetTrustLevel, VarPtr(value)) = S_OK Then
            GetTrustLevel = value
        End If
    End If
End Function

Public Sub Dispose(ByRef pInterface As Long)
    If pInterface <> 0& Then
        Dim pIClosable As Long
        If InvokeIfc(pInterface, IUnknown_QueryInterface, _
                     VarPtr(Str2Guid(IID_IClosable)), _
                     VarPtr(pIClosable)) = S_OK Then
            Call InvokeIfc(pIClosable, IClosable_Close)
            Call ReleaseIfc(pIClosable)
            Call ReleaseIfc(pInterface)
            pInterface = 0&
        End If
    End If
End Sub

' ----==== Interface Functions ====----
Public Function QueryIfc(ByVal pInterface As Long, _
                         ByVal iid As String, _
                         ByRef ppInterface As Long) As Boolean
    If pInterface <> 0& Then
        If InvokeIfc(pInterface, IUnknown_QueryInterface, _
                     VarPtr(Str2Guid(iid)), VarPtr(ppInterface)) = S_OK Then
            If ppInterface <> 0& Then QueryIfc = True
        End If
    End If
End Function

Public Sub ReleaseIfc(ByRef pInterface As Long)
    If pInterface <> 0& Then
        Call InvokeIfc(pInterface, _
                       IUnknown_Release)
        pInterface = 0&
    End If
End Sub

Private Function InvokeIfc(ByVal pInterface As Long, _
                           ByVal vtb As vtb_Interfaces, _
                           ParamArray var()) As Variant
    If pInterface <> 0& Then
        InvokeIfc = OleInvoke(pInterface, vtb, var)
    End If
End Function

Public Function OleInvoke(ByVal pInterface As Long, _
                          ByVal lngCmd As Long, _
                          ParamArray aParam()) As Variant
    If pInterface <> 0& Then
        If UBound(aParam) >= 0& Then
            Dim varParam As Variant
            varParam = aParam
            If IsArray(varParam) Then varParam = varParam(0)
            Dim lngCount As Long
            lngCount = UBound(varParam)
            Dim lngItem As Long
            Dim olePtr(10) As Long
            Dim oleTyp(10) As Integer
            For lngItem = 0& To lngCount
                oleTyp(lngItem) = VarType(varParam(lngItem))
                olePtr(lngItem) = VarPtr(varParam(lngItem))
            Next
        End If
        Dim varRet As Variant
        If DispCallFunc(pInterface, lngCmd * 4, CC_STDCALL, _
                        vbLong, lngItem, VarPtr(oleTyp(0)), _
                        VarPtr(olePtr(0)), varRet) <> S_OK Then
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"
        End If

'        If varRet <> S_OK Then
'            Debug.Print "0x" & Hex$(varRet)
'        End If
    End If
    OleInvoke = varRet
End Function

' ----==== Helper Functions ====----
Public Function ProcPtr(ByVal ptr As Long) As Long
    ProcPtr = ptr
End Function

Private Function Str2Guid(ByVal strGUID As String) As GUID
    If Len(strGUID) = 38 Then
        Call CLSIDFromString(StrPtr(strGUID), Str2Guid)
    End If
End Function

Public Function Guid2Str(ByRef tGUID As GUID) As String
    Dim lngRet As Long
    Dim strGUID As String
    strGUID = String(40, 0)
    lngRet = StringFromGUID(tGUID, StrPtr(strGUID), Len(strGUID))
    If lngRet > 0& Then
        Guid2Str = Left$(strGUID, lngRet - 1)
    Else
        Guid2Str = vbNullString
    End If
End Function

Private Function Ptr2Str(ByVal lpStr As Long) As String
    Dim lngLen As Long
    Dim bytBuffer() As Byte
    lngLen = lstrlenW(lpStr) * 2
    If lngLen > 0 Then
        ReDim bytBuffer(lngLen - 1)
        Call CopyMemory(bytBuffer(0), ByVal lpStr, lngLen)
        Call CoTaskMemFree(lpStr)
        Ptr2Str = bytBuffer
    End If
End Function

Public Function NewRect(ByVal X As Single, _
                        ByVal Y As Single, _
                        ByVal Width As Single, _
                        ByVal Height As Single) As Rect
    NewRect.X = X
    NewRect.Y = Y
    NewRect.Width = Width
    NewRect.Height = Height
End Function

Public Function NewColor(ByVal R As Byte, _
                         ByVal G As Byte, _
                         ByVal B As Byte, _
                         Optional ByVal A As Byte = 255) As Color
    NewColor.A = A
    NewColor.R = R
    NewColor.G = G
    NewColor.B = B
End Function

Public Function Color2Long(ByRef value As Color) As Long
    Call CopyMemory(Color2Long, value, 4)
End Function
